   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
  46                     ; 23 unsigned char functionButtonKnob(void){
  48                     	switch	.text
  49  0000               _functionButtonKnob:
  51  0000 89            	pushw	x
  52       00000002      OFST:	set	2
  55                     ; 26   ADC_StartConversion();
  57  0001 cd0000        	call	_ADC_StartConversion
  60  0004               L13:
  61                     ; 27 	while (ADC_GetFlagStatus(ADC_FLAG_EOC) == SET);
  63  0004 a680          	ld	a,#128
  64  0006 cd0000        	call	_ADC_GetFlagStatus
  66  0009 a101          	cp	a,#1
  67  000b 27f7          	jreq	L13
  68                     ; 28   a = (ADC_GetConversionValue() >> 2);
  70  000d cd0000        	call	_ADC_GetConversionValue
  72  0010 54            	srlw	x
  73  0011 54            	srlw	x
  74  0012 1f01          	ldw	(OFST-1,sp),x
  75                     ; 29   return (unsigned char)a;
  77  0014 7b02          	ld	a,(OFST+0,sp)
  80  0016 85            	popw	x
  81  0017 81            	ret
 112                     ; 32 void BC_ADC_Configuration(void)
 112                     ; 33 {
 113                     	switch	.text
 114  0018               _BC_ADC_Configuration:
 118                     ; 35   GPIO_Init(ADC_Port, ADC_Pin, GPIO_MODE_IN_FL_NO_IT);
 120  0018 4b00          	push	#0
 121  001a 4b40          	push	#64
 122  001c ae5014        	ldw	x,#20500
 123  001f cd0000        	call	_GPIO_Init
 125  0022 85            	popw	x
 126                     ; 36   ADC_DeInit();
 128  0023 cd0000        	call	_ADC_DeInit
 130                     ; 38   ADC_Init(ADC_CONVERSIONMODE_SINGLE, ADC_CHANNEL_9, ADC_PRESSEL_FCPU_D2, ADC_EXTTRIG_GPIO, DISABLE, ADC_ALIGN_RIGHT, ADC_SCHMITTTRIG_CHANNEL9, DISABLE);
 132  0026 4b00          	push	#0
 133  0028 4b09          	push	#9
 134  002a 4b08          	push	#8
 135  002c 4b00          	push	#0
 136  002e 4b10          	push	#16
 137  0030 4b00          	push	#0
 138  0032 ae0009        	ldw	x,#9
 139  0035 4f            	clr	a
 140  0036 95            	ld	xh,a
 141  0037 cd0000        	call	_ADC_Init
 143  003a 5b06          	addw	sp,#6
 144                     ; 39   ADC_Cmd(ENABLE);
 146  003c a601          	ld	a,#1
 147  003e cd0000        	call	_ADC_Cmd
 149                     ; 40   buttonsADC.buttonKnob = functionButtonKnob;
 151  0041 ae0000        	ldw	x,#_functionButtonKnob
 152  0044 bf03          	ldw	_buttonsADC+3,x
 153                     ; 41 }
 156  0046 81            	ret
 181                     ; 43 void BC_GPIO_Configuration(void)
 181                     ; 44 {
 182                     	switch	.text
 183  0047               _BC_GPIO_Configuration:
 187                     ; 46   GPIO_Init(ButtonLeftRight_Port, (ButtonLeft_Pin | ButtonRight_Pin), GPIO_MODE_IN_FL_IT);
 189  0047 4b20          	push	#32
 190  0049 4b30          	push	#48
 191  004b ae5005        	ldw	x,#20485
 192  004e cd0000        	call	_GPIO_Init
 194  0051 85            	popw	x
 195                     ; 48 	GPIO_Init(ButtonSelect_Port, ButtonSelect_Pin, GPIO_MODE_IN_FL_IT);
 197  0052 4b20          	push	#32
 198  0054 4b80          	push	#128
 199  0056 ae500f        	ldw	x,#20495
 200  0059 cd0000        	call	_GPIO_Init
 202  005c 85            	popw	x
 203                     ; 50 }
 206  005d 81            	ret
 234                     ; 52 void BC_EXTI_Configuration(void)
 234                     ; 53 {
 235                     	switch	.text
 236  005e               _BC_EXTI_Configuration:
 240                     ; 54   disableInterrupts();
 243  005e 9b            sim
 245                     ; 56   EXTI_SetExtIntSensitivity(EXTI_PORT_ButtonLeftRight, EXTI_SENSITIVITY_FALL_ONLY);
 248  005f ae0002        	ldw	x,#2
 249  0062 a601          	ld	a,#1
 250  0064 95            	ld	xh,a
 251  0065 cd0000        	call	_EXTI_SetExtIntSensitivity
 253                     ; 57   EXTI_SetExtIntSensitivity(EXTI_PORT_ButtonSelect, EXTI_SENSITIVITY_FALL_ONLY);
 255  0068 ae0002        	ldw	x,#2
 256  006b a603          	ld	a,#3
 257  006d 95            	ld	xh,a
 258  006e cd0000        	call	_EXTI_SetExtIntSensitivity
 260                     ; 58   EXTI_SetTLISensitivity(EXTI_SENSITIVITY_FALL_ONLY);
 262  0071 a602          	ld	a,#2
 263  0073 cd0000        	call	_EXTI_SetTLISensitivity
 265                     ; 59   enableInterrupts();
 268  0076 9a            rim
 270                     ; 60 }
 274  0077 81            	ret
 338                     	xdef	_functionButtonKnob
 339                     	switch	.ubsct
 340  0000               _buttonsADC:
 341  0000 0000000000    	ds.b	5
 342                     	xdef	_buttonsADC
 343                     	xdef	_BC_EXTI_Configuration
 344                     	xdef	_BC_GPIO_Configuration
 345                     	xdef	_BC_ADC_Configuration
 346                     	xref	_GPIO_Init
 347                     	xref	_EXTI_SetTLISensitivity
 348                     	xref	_EXTI_SetExtIntSensitivity
 349                     	xref	_ADC_GetFlagStatus
 350                     	xref	_ADC_GetConversionValue
 351                     	xref	_ADC_StartConversion
 352                     	xref	_ADC_Cmd
 353                     	xref	_ADC_Init
 354                     	xref	_ADC_DeInit
 374                     	end
