   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
   4                     	bsct
   5  0000               _actual_streamSize:
   6  0000 0001          	dc.w	1
  64                     ; 49 void fillDriver(int LEDcount){
  66                     	switch	.text
  67  0000               _fillDriver:
  69  0000 89            	pushw	x
  70  0001 5204          	subw	sp,#4
  71       00000004      OFST:	set	4
  74                     ; 52   streamSizeToTest = LEDcount / 8;
  76  0003 a608          	ld	a,#8
  77  0005 cd0000        	call	c_sdivx
  79  0008 1f01          	ldw	(OFST-3,sp),x
  80                     ; 53   if(streamSizeToTest*8 < LEDcount)
  82  000a 1e01          	ldw	x,(OFST-3,sp)
  83  000c 58            	sllw	x
  84  000d 58            	sllw	x
  85  000e 58            	sllw	x
  86  000f 1305          	cpw	x,(OFST+1,sp)
  87  0011 2407          	jruge	L73
  88                     ; 54     streamSizeToTest++;
  90  0013 1e01          	ldw	x,(OFST-3,sp)
  91  0015 1c0001        	addw	x,#1
  92  0018 1f01          	ldw	(OFST-3,sp),x
  93  001a               L73:
  94                     ; 56   for(i = 0; i < streamSizeToTest; i++){
  96  001a 5f            	clrw	x
  97  001b 1f03          	ldw	(OFST-1,sp),x
  99  001d 2012          	jra	L54
 100  001f               L14:
 101                     ; 57     SPI->DR = 0x00;
 103  001f 725f5204      	clr	20996
 105  0023               L55:
 106                     ; 58     while ((SPI->SR & SPI_SR_TXE) == 0);
 108  0023 c65203        	ld	a,20995
 109  0026 a502          	bcp	a,#2
 110  0028 27f9          	jreq	L55
 111                     ; 56   for(i = 0; i < streamSizeToTest; i++){
 113  002a 1e03          	ldw	x,(OFST-1,sp)
 114  002c 1c0001        	addw	x,#1
 115  002f 1f03          	ldw	(OFST-1,sp),x
 116  0031               L54:
 119  0031 1e03          	ldw	x,(OFST-1,sp)
 120  0033 1301          	cpw	x,(OFST-3,sp)
 121  0035 25e8          	jrult	L14
 122                     ; 60 }  
 125  0037 5b06          	addw	sp,#6
 126  0039 81            	ret
 217                     ; 62 int setup(int LEDcount, int PWMdepth, int requestedRefreshRate){ //set up refresh rate, configure interrupts and DMA
 218                     	switch	.text
 219  003a               _setup:
 221  003a 89            	pushw	x
 222  003b 5210          	subw	sp,#16
 223       00000010      OFST:	set	16
 226                     ; 65   TotalTime = (2.25 + 0.055 * LEDcount) * 0.000001;  //this is valid for about 10MHz of SPI
 228  003d cd0000        	call	c_itof
 230  0040 ae0008        	ldw	x,#L721
 231  0043 cd0000        	call	c_fmul
 233  0046 ae000c        	ldw	x,#L731
 234  0049 cd0000        	call	c_fadd
 236  004c ae0004        	ldw	x,#L741
 237  004f cd0000        	call	c_fmul
 239  0052 96            	ldw	x,sp
 240  0053 1c0009        	addw	x,#OFST-7
 241  0056 cd0000        	call	c_rtol
 243                     ; 66   SystickTime = 1.0 / ((float)requestedRefreshRate * (float)PWMdepth);
 245  0059 1e15          	ldw	x,(OFST+5,sp)
 246  005b cd0000        	call	c_itof
 248  005e 96            	ldw	x,sp
 249  005f 1c0005        	addw	x,#OFST-11
 250  0062 cd0000        	call	c_rtol
 252  0065 1e17          	ldw	x,(OFST+7,sp)
 253  0067 cd0000        	call	c_itof
 255  006a 96            	ldw	x,sp
 256  006b 1c0005        	addw	x,#OFST-11
 257  006e cd0000        	call	c_fmul
 259  0071 96            	ldw	x,sp
 260  0072 1c0001        	addw	x,#OFST-15
 261  0075 cd0000        	call	c_rtol
 263  0078 ae0000        	ldw	x,#L751
 264  007b cd0000        	call	c_ltor
 266  007e 96            	ldw	x,sp
 267  007f 1c0001        	addw	x,#OFST-15
 268  0082 cd0000        	call	c_fdiv
 270  0085 96            	ldw	x,sp
 271  0086 1c000d        	addw	x,#OFST-3
 272  0089 cd0000        	call	c_rtol
 274                     ; 68   if(SystickTime < TotalTime)  //the values requested cannot be reached
 276  008c 9c            	rvf
 277  008d 96            	ldw	x,sp
 278  008e 1c000d        	addw	x,#OFST-3
 279  0091 cd0000        	call	c_ltor
 281  0094 96            	ldw	x,sp
 282  0095 1c0009        	addw	x,#OFST-7
 283  0098 cd0000        	call	c_fcmp
 285  009b 2e03          	jrsge	L361
 286                     ; 69     return ERROR;
 288  009d 5f            	clrw	x
 290  009e 2076          	jra	L01
 291  00a0               L361:
 292                     ; 72   PreloadValue = 24000000l / (requestedRefreshRate * PWMdepth);
 294  00a0 1e17          	ldw	x,(OFST+7,sp)
 295  00a2 1615          	ldw	y,(OFST+5,sp)
 296  00a4 cd0000        	call	c_imul
 298  00a7 cd0000        	call	c_itolx
 300  00aa 96            	ldw	x,sp
 301  00ab 1c0005        	addw	x,#OFST-11
 302  00ae cd0000        	call	c_rtol
 304  00b1 ae3600        	ldw	x,#13824
 305  00b4 bf02          	ldw	c_lreg+2,x
 306  00b6 ae016e        	ldw	x,#366
 307  00b9 bf00          	ldw	c_lreg,x
 308  00bb 96            	ldw	x,sp
 309  00bc 1c0005        	addw	x,#OFST-11
 310  00bf cd0000        	call	c_ldiv
 312  00c2 96            	ldw	x,sp
 313  00c3 1c000d        	addw	x,#OFST-3
 314  00c6 cd0000        	call	c_rtol
 316                     ; 74   TIM1_TimeBaseInit(0, TIM1_COUNTERMODE_UP, PreloadValue, 0);
 318  00c9 4b00          	push	#0
 319  00cb 1e10          	ldw	x,(OFST+0,sp)
 320  00cd 89            	pushw	x
 321  00ce 4b00          	push	#0
 322  00d0 5f            	clrw	x
 323  00d1 cd0000        	call	_TIM1_TimeBaseInit
 325  00d4 5b04          	addw	sp,#4
 326                     ; 75   TIM1_Cmd(DISABLE);
 328  00d6 4f            	clr	a
 329  00d7 cd0000        	call	_TIM1_Cmd
 331                     ; 76   TIM1_ITConfig(TIM1_IT_UPDATE, ENABLE);
 333  00da ae0001        	ldw	x,#1
 334  00dd a601          	ld	a,#1
 335  00df 95            	ld	xh,a
 336  00e0 cd0000        	call	_TIM1_ITConfig
 338                     ; 77   enableInterrupts();
 341  00e3 9a            rim
 343                     ; 79   actual_streamSize = LEDcount / 8;
 346  00e4 1e11          	ldw	x,(OFST+1,sp)
 347  00e6 a608          	ld	a,#8
 348  00e8 cd0000        	call	c_sdivx
 350  00eb bf00          	ldw	_actual_streamSize,x
 351                     ; 80   if(actual_streamSize*8 < LEDcount)
 353  00ed be00          	ldw	x,_actual_streamSize
 354  00ef 58            	sllw	x
 355  00f0 58            	sllw	x
 356  00f1 58            	sllw	x
 357  00f2 1311          	cpw	x,(OFST+1,sp)
 358  00f4 2407          	jruge	L561
 359                     ; 81     actual_streamSize++;  
 361  00f6 be00          	ldw	x,_actual_streamSize
 362  00f8 1c0001        	addw	x,#1
 363  00fb bf00          	ldw	_actual_streamSize,x
 364  00fd               L561:
 365                     ; 83   released_table_start     = new_table_start     = actual_table_start     = NULL;
 367  00fd 5f            	clrw	x
 368  00fe bf13          	ldw	_actual_table_start,x
 369  0100 be13          	ldw	x,_actual_table_start
 370  0102 bf0d          	ldw	_new_table_start,x
 371  0104 be0d          	ldw	x,_new_table_start
 372  0106 bf07          	ldw	_released_table_start,x
 373                     ; 84   released_table_key_start = new_table_key_start = actual_table_key_start = NULL;
 375  0108 5f            	clrw	x
 376  0109 bf11          	ldw	_actual_table_key_start,x
 377  010b be11          	ldw	x,_actual_table_key_start
 378  010d bf0b          	ldw	_new_table_key_start,x
 379  010f be0b          	ldw	x,_new_table_key_start
 380  0111 bf05          	ldw	_released_table_key_start,x
 381                     ; 86   return SUCCESS;
 383  0113 ae0001        	ldw	x,#1
 385  0116               L01:
 387  0116 5b12          	addw	sp,#18
 388  0118 81            	ret
 488                     ; 91 unsigned char error_detection_DMX(unsigned char *LEDmapIN, int LEDcount){
 489                     	switch	.text
 490  0119               _error_detection_DMX:
 492  0119 89            	pushw	x
 493  011a 520a          	subw	sp,#10
 494       0000000a      OFST:	set	10
 497                     ; 95   streamSizeToTest = LEDcount / 8;
 499  011c 1e0f          	ldw	x,(OFST+5,sp)
 500  011e a608          	ld	a,#8
 501  0120 cd0000        	call	c_sdivx
 503  0123 1f03          	ldw	(OFST-7,sp),x
 504                     ; 96   if(streamSizeToTest*8 < LEDcount)
 506  0125 1e03          	ldw	x,(OFST-7,sp)
 507  0127 58            	sllw	x
 508  0128 58            	sllw	x
 509  0129 58            	sllw	x
 510  012a 130f          	cpw	x,(OFST+5,sp)
 511  012c 2407          	jruge	L532
 512                     ; 97     streamSizeToTest++;  
 514  012e 1e03          	ldw	x,(OFST-7,sp)
 515  0130 1c0001        	addw	x,#1
 516  0133 1f03          	ldw	(OFST-7,sp),x
 517  0135               L532:
 518                     ; 99   stop_dimmer();
 520  0135 cd0468        	call	_stop_dimmer
 522                     ; 100   LED_driver_OutDisable_All_Off();//LED_driver_OutDisable(1); LED_driver_OutDisable(2);
 524  0138 cd04a4        	call	_LED_driver_OutDisable_All_Off
 526                     ; 102   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();
 528  013b 4b08          	push	#8
 529  013d ae500a        	ldw	x,#20490
 530  0140 cd0000        	call	_GPIO_WriteHigh
 532  0143 84            	pop	a
 533                     ; 104   for(i = 0; i < 6; i++){
 535  0144 5f            	clrw	x
 536  0145 1f09          	ldw	(OFST-1,sp),x
 537  0147               L732:
 538                     ; 105     SPI->DR =  0xFF;
 540  0147 35ff5204      	mov	20996,#255
 542  014b               L152:
 543                     ; 106     while ((SPI->SR & SPI_SR_TXE) == 0);
 545  014b c65203        	ld	a,20995
 546  014e a502          	bcp	a,#2
 547  0150 27f9          	jreq	L152
 548                     ; 104   for(i = 0; i < 6; i++){
 550  0152 1e09          	ldw	x,(OFST-1,sp)
 551  0154 1c0001        	addw	x,#1
 552  0157 1f09          	ldw	(OFST-1,sp),x
 555  0159 1e09          	ldw	x,(OFST-1,sp)
 556  015b a30006        	cpw	x,#6
 557  015e 25e7          	jrult	L732
 558                     ; 109   GPIO_WriteLow(LE_PORT, LE_PIN); //FAST_LE_LOW();
 560  0160 4b08          	push	#8
 561  0162 ae500a        	ldw	x,#20490
 562  0165 cd0000        	call	_GPIO_WriteLow
 564  0168 84            	pop	a
 565                     ; 110   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();
 567  0169 4b08          	push	#8
 568  016b ae500a        	ldw	x,#20490
 569  016e cd0000        	call	_GPIO_WriteHigh
 571  0171 84            	pop	a
 572                     ; 111   GPIO_WriteLow(LE_PORT, LE_PIN); //FAST_LE_LOW();
 574  0172 4b08          	push	#8
 575  0174 ae500a        	ldw	x,#20490
 576  0177 cd0000        	call	_GPIO_WriteLow
 578  017a 84            	pop	a
 579                     ; 112   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();
 581  017b 4b08          	push	#8
 582  017d ae500a        	ldw	x,#20490
 583  0180 cd0000        	call	_GPIO_WriteHigh
 585  0183 84            	pop	a
 586                     ; 114 	SPI_Cmd(DISABLE);
 588  0184 4f            	clr	a
 589  0185 cd0000        	call	_SPI_Cmd
 591                     ; 115   GPIO_WriteHigh(SPI_PORT, SPI_MOSI_PIN); 
 593  0188 4b40          	push	#64
 594  018a ae500a        	ldw	x,#20490
 595  018d cd0000        	call	_GPIO_WriteHigh
 597  0190 84            	pop	a
 598                     ; 117   SPI_CLK_HIGH();
 600  0191 cd05b3        	call	_SPI_CLK_HIGH
 602                     ; 118   SPI_CLK_LOW();
 604  0194 cd05a9        	call	_SPI_CLK_LOW
 606                     ; 120   GPIO_WriteLow(DM_PORT, DM_PIN); //entering diagnostic mode
 608  0197 4b08          	push	#8
 609  0199 ae5005        	ldw	x,#20485
 610  019c cd0000        	call	_GPIO_WriteLow
 612  019f 84            	pop	a
 613                     ; 122       SPI_CLK_LOW();SPI_CLK_LOW();SPI_CLK_LOW();SPI_CLK_LOW();
 615  01a0 cd05a9        	call	_SPI_CLK_LOW
 619  01a3 cd05a9        	call	_SPI_CLK_LOW
 623  01a6 cd05a9        	call	_SPI_CLK_LOW
 627  01a9 cd05a9        	call	_SPI_CLK_LOW
 629                     ; 126   LED_driver_OutEnable_All_On(); //LED_driver_OutEnable(1); LED_driver_OutEnable(2);
 631  01ac cd046d        	call	_LED_driver_OutEnable_All_On
 633                     ; 128       SPI_CLK_LOW();SPI_CLK_LOW();
 635  01af cd05a9        	call	_SPI_CLK_LOW
 639  01b2 cd05a9        	call	_SPI_CLK_LOW
 641                     ; 129   SPI_CLK_HIGH();
 643  01b5 cd05b3        	call	_SPI_CLK_HIGH
 645                     ; 130   SPI_CLK_LOW();
 647  01b8 cd05a9        	call	_SPI_CLK_LOW
 649                     ; 131   SPI_CLK_HIGH();
 651  01bb cd05b3        	call	_SPI_CLK_HIGH
 653                     ; 132   SPI_CLK_LOW();
 655  01be cd05a9        	call	_SPI_CLK_LOW
 657                     ; 134   for(i=0; i<3; i++)  
 659  01c1 5f            	clrw	x
 660  01c2 1f09          	ldw	(OFST-1,sp),x
 661  01c4               L552:
 662                     ; 135       X = 10+i+y;    
 664  01c4 1e01          	ldw	x,(OFST-9,sp)
 665  01c6 1e09          	ldw	x,(OFST-1,sp)
 666  01c8 72fb07        	addw	x,(OFST-3,sp)
 667  01cb 1c000a        	addw	x,#10
 668                     ; 134   for(i=0; i<3; i++)  
 670  01ce 1e09          	ldw	x,(OFST-1,sp)
 671  01d0 1c0001        	addw	x,#1
 672  01d3 1f09          	ldw	(OFST-1,sp),x
 675  01d5 1e09          	ldw	x,(OFST-1,sp)
 676  01d7 a30003        	cpw	x,#3
 677  01da 25e8          	jrult	L552
 678                     ; 137   SPI_CLK_HIGH();
 680  01dc cd05b3        	call	_SPI_CLK_HIGH
 682                     ; 138   SPI_CLK_LOW();
 684  01df cd05a9        	call	_SPI_CLK_LOW
 686                     ; 140     SPI_CLK_LOW();  SPI_CLK_LOW();
 688  01e2 cd05a9        	call	_SPI_CLK_LOW
 692  01e5 cd05a9        	call	_SPI_CLK_LOW
 694                     ; 142   LED_driver_OutDisable_All_Off();//LED_driver_OutDisable(1); LED_driver_OutDisable(2);  
 696  01e8 cd04a4        	call	_LED_driver_OutDisable_All_Off
 698                     ; 144   GPIO_WriteHigh(DM_PORT, DM_PIN);  //leaving diagnostic mode  
 700  01eb 4b08          	push	#8
 701  01ed ae5005        	ldw	x,#20485
 702  01f0 cd0000        	call	_GPIO_WriteHigh
 704  01f3 84            	pop	a
 705                     ; 146   SPI_Cmd(ENABLE);
 707  01f4 a601          	ld	a,#1
 708  01f6 cd0000        	call	_SPI_Cmd
 710                     ; 148   eFlag = 0;
 712  01f9 5f            	clrw	x
 713  01fa 1f05          	ldw	(OFST-5,sp),x
 714                     ; 149   DATAIN = SPI_ReceiveData();  //clear the input buffer flag
 716  01fc cd0000        	call	_SPI_ReceiveData
 718  01ff b700          	ld	_DATAIN,a
 719                     ; 150   SPI->DR =  0x00;
 721  0201 725f5204      	clr	20996
 722                     ; 151   for(i = 0; i < (streamSizeToTest); i++){
 724  0205 5f            	clrw	x
 725  0206 1f09          	ldw	(OFST-1,sp),x
 727  0208 2062          	jra	L762
 728  020a               L572:
 729                     ; 152     while ((SPI->SR & SPI_SR_TXE) == 0);
 731  020a c65203        	ld	a,20995
 732  020d a502          	bcp	a,#2
 733  020f 27f9          	jreq	L572
 735  0211               L303:
 736                     ; 153     while ((SPI->SR & SPI_SR_RXNE) == 0);
 738  0211 c65203        	ld	a,20995
 739  0214 a501          	bcp	a,#1
 740  0216 27f9          	jreq	L303
 741                     ; 154     DATAIN = SPI_ReceiveData();  
 743  0218 cd0000        	call	_SPI_ReceiveData
 745  021b b700          	ld	_DATAIN,a
 746                     ; 156     SPI->DR =  0x00;
 748  021d 725f5204      	clr	20996
 749                     ; 157     for(y = 0; y<8; y++)
 751  0221 5f            	clrw	x
 752  0222 1f07          	ldw	(OFST-3,sp),x
 753  0224               L703:
 754                     ; 158       if((DATAIN << y) & 0x80)
 756  0224 b600          	ld	a,_DATAIN
 757  0226 5f            	clrw	x
 758  0227 97            	ld	xl,a
 759  0228 7b08          	ld	a,(OFST-2,sp)
 760  022a 4d            	tnz	a
 761  022b 2704          	jreq	L41
 762  022d               L61:
 763  022d 58            	sllw	x
 764  022e 4a            	dec	a
 765  022f 26fc          	jrne	L61
 766  0231               L41:
 767  0231 01            	rrwa	x,a
 768  0232 a580          	bcp	a,#128
 769  0234 2710          	jreq	L513
 770                     ; 159         LEDmapIN[(i*8+y)] = 1;
 772  0236 1e09          	ldw	x,(OFST-1,sp)
 773  0238 58            	sllw	x
 774  0239 58            	sllw	x
 775  023a 58            	sllw	x
 776  023b 72fb07        	addw	x,(OFST-3,sp)
 777  023e 72fb0b        	addw	x,(OFST+1,sp)
 778  0241 a601          	ld	a,#1
 779  0243 f7            	ld	(x),a
 781  0244 2011          	jra	L713
 782  0246               L513:
 783                     ; 161         LEDmapIN[(i*8+y)] = 0;
 785  0246 1e09          	ldw	x,(OFST-1,sp)
 786  0248 58            	sllw	x
 787  0249 58            	sllw	x
 788  024a 58            	sllw	x
 789  024b 72fb07        	addw	x,(OFST-3,sp)
 790  024e 72fb0b        	addw	x,(OFST+1,sp)
 791  0251 7f            	clr	(x)
 792                     ; 162         eFlag = 1;        
 794  0252 ae0001        	ldw	x,#1
 795  0255 1f05          	ldw	(OFST-5,sp),x
 796  0257               L713:
 797                     ; 157     for(y = 0; y<8; y++)
 799  0257 1e07          	ldw	x,(OFST-3,sp)
 800  0259 1c0001        	addw	x,#1
 801  025c 1f07          	ldw	(OFST-3,sp),x
 804  025e 1e07          	ldw	x,(OFST-3,sp)
 805  0260 a30008        	cpw	x,#8
 806  0263 25bf          	jrult	L703
 807                     ; 151   for(i = 0; i < (streamSizeToTest); i++){
 809  0265 1e09          	ldw	x,(OFST-1,sp)
 810  0267 1c0001        	addw	x,#1
 811  026a 1f09          	ldw	(OFST-1,sp),x
 812  026c               L762:
 815  026c 1e09          	ldw	x,(OFST-1,sp)
 816  026e 1303          	cpw	x,(OFST-7,sp)
 817  0270 2598          	jrult	L572
 818                     ; 171   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();   //new
 820  0272 4b08          	push	#8
 821  0274 ae500a        	ldw	x,#20490
 822  0277 cd0000        	call	_GPIO_WriteHigh
 824  027a 84            	pop	a
 825                     ; 172   GPIO_WriteLow(LE_PORT, LE_PIN); //FAST_LE_LOW();    //new
 827  027b 4b08          	push	#8
 828  027d ae500a        	ldw	x,#20490
 829  0280 cd0000        	call	_GPIO_WriteLow
 831  0283 84            	pop	a
 832                     ; 174   return eFlag;
 834  0284 7b06          	ld	a,(OFST-4,sp)
 837  0286 5b0c          	addw	sp,#12
 838  0288 81            	ret
 938                     ; 177 unsigned char error_detection_LE_OE(unsigned char *LEDmapIN, int LEDcount){
 939                     	switch	.text
 940  0289               _error_detection_LE_OE:
 942  0289 89            	pushw	x
 943  028a 520a          	subw	sp,#10
 944       0000000a      OFST:	set	10
 947                     ; 182   stop_dimmer();
 949  028c cd0468        	call	_stop_dimmer
 951                     ; 184   LED_driver_OutDisable_All_Off(); //LED_driver_OutDisable(1); LED_driver_OutDisable(2);
 953  028f cd04a4        	call	_LED_driver_OutDisable_All_Off
 955                     ; 186   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();
 957  0292 4b08          	push	#8
 958  0294 ae500a        	ldw	x,#20490
 959  0297 cd0000        	call	_GPIO_WriteHigh
 961  029a 84            	pop	a
 962                     ; 188   streamSizeToTest = LEDcount / 8;
 964  029b 1e0f          	ldw	x,(OFST+5,sp)
 965  029d a608          	ld	a,#8
 966  029f cd0000        	call	c_sdivx
 968  02a2 1f05          	ldw	(OFST-5,sp),x
 969                     ; 189   if(streamSizeToTest*8 < LEDcount)
 971  02a4 1e05          	ldw	x,(OFST-5,sp)
 972  02a6 58            	sllw	x
 973  02a7 58            	sllw	x
 974  02a8 58            	sllw	x
 975  02a9 130f          	cpw	x,(OFST+5,sp)
 976  02ab 2407          	jruge	L763
 977                     ; 190     streamSizeToTest++;
 979  02ad 1e05          	ldw	x,(OFST-5,sp)
 980  02af 1c0001        	addw	x,#1
 981  02b2 1f05          	ldw	(OFST-5,sp),x
 982  02b4               L763:
 983                     ; 192   for(i = 0; i < streamSizeToTest; i++){
 985  02b4 5f            	clrw	x
 986  02b5 1f09          	ldw	(OFST-1,sp),x
 988  02b7 2012          	jra	L573
 989  02b9               L173:
 990                     ; 193     SPI->DR =  0xFF;
 992  02b9 35ff5204      	mov	20996,#255
 994  02bd               L504:
 995                     ; 194     while ((SPI->SR & SPI_SR_TXE) == 0);
 997  02bd c65203        	ld	a,20995
 998  02c0 a502          	bcp	a,#2
 999  02c2 27f9          	jreq	L504
1000                     ; 192   for(i = 0; i < streamSizeToTest; i++){
1002  02c4 1e09          	ldw	x,(OFST-1,sp)
1003  02c6 1c0001        	addw	x,#1
1004  02c9 1f09          	ldw	(OFST-1,sp),x
1005  02cb               L573:
1008  02cb 1e09          	ldw	x,(OFST-1,sp)
1009  02cd 1305          	cpw	x,(OFST-5,sp)
1010  02cf 25e8          	jrult	L173
1011                     ; 197   SPI_Cmd(DISABLE);
1013  02d1 4f            	clr	a
1014  02d2 cd0000        	call	_SPI_Cmd
1016                     ; 198   GPIO_WriteHigh(SPI_PORT, SPI_MOSI_PIN); 
1018  02d5 4b40          	push	#64
1019  02d7 ae500a        	ldw	x,#20490
1020  02da cd0000        	call	_GPIO_WriteHigh
1022  02dd 84            	pop	a
1023                     ; 201   GPIO_WriteLow(LE_PORT, LE_PIN); //LE=0
1025  02de 4b08          	push	#8
1026  02e0 ae500a        	ldw	x,#20490
1027  02e3 cd0000        	call	_GPIO_WriteLow
1029  02e6 84            	pop	a
1030                     ; 202   SPI_CLK_LOW();
1032  02e7 cd05a9        	call	_SPI_CLK_LOW
1034                     ; 205   SPI_CLK_HIGH();
1036  02ea cd05b3        	call	_SPI_CLK_HIGH
1038                     ; 206   SPI_CLK_LOW();
1040  02ed cd05a9        	call	_SPI_CLK_LOW
1042                     ; 207   LED_driver_OutEnable_All_On(); //LED_driver_OutEnable(1); LED_driver_OutEnable(2);
1044  02f0 cd046d        	call	_LED_driver_OutEnable_All_On
1046                     ; 208   SPI_CLK_HIGH();
1048  02f3 cd05b3        	call	_SPI_CLK_HIGH
1050                     ; 209   SPI_CLK_LOW();
1052  02f6 cd05a9        	call	_SPI_CLK_LOW
1054                     ; 210   LED_driver_OutDisable_All_Off(); //LED_driver_OutDisable(1); LED_driver_OutDisable(2);
1056  02f9 cd04a4        	call	_LED_driver_OutDisable_All_Off
1058                     ; 211   SPI_CLK_HIGH();
1060  02fc cd05b3        	call	_SPI_CLK_HIGH
1062                     ; 212   SPI_CLK_LOW();
1064  02ff cd05a9        	call	_SPI_CLK_LOW
1066                     ; 213   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH();
1068  0302 4b08          	push	#8
1069  0304 ae500a        	ldw	x,#20490
1070  0307 cd0000        	call	_GPIO_WriteHigh
1072  030a 84            	pop	a
1073                     ; 214   SPI_CLK_HIGH();
1075  030b cd05b3        	call	_SPI_CLK_HIGH
1077                     ; 215   SPI_CLK_LOW();
1079  030e cd05a9        	call	_SPI_CLK_LOW
1081                     ; 216   GPIO_WriteLow(LE_PORT, LE_PIN);  //FAST_LE_low();
1083  0311 4b08          	push	#8
1084  0313 ae500a        	ldw	x,#20490
1085  0316 cd0000        	call	_GPIO_WriteLow
1087  0319 84            	pop	a
1088                     ; 217   SPI_CLK_HIGH();
1090  031a cd05b3        	call	_SPI_CLK_HIGH
1092                     ; 218   SPI_CLK_LOW();
1094  031d cd05a9        	call	_SPI_CLK_LOW
1096                     ; 221   for(i = 0; i < 48; i++){  //filling of 48 ones in to the driver
1098  0320 5f            	clrw	x
1099  0321 1f09          	ldw	(OFST-1,sp),x
1100  0323               L114:
1101                     ; 222     SPI_CLK_HIGH();
1103  0323 cd05b3        	call	_SPI_CLK_HIGH
1105                     ; 223     SPI_CLK_LOW();
1107  0326 cd05a9        	call	_SPI_CLK_LOW
1109                     ; 221   for(i = 0; i < 48; i++){  //filling of 48 ones in to the driver
1111  0329 1e09          	ldw	x,(OFST-1,sp)
1112  032b 1c0001        	addw	x,#1
1113  032e 1f09          	ldw	(OFST-1,sp),x
1116  0330 1e09          	ldw	x,(OFST-1,sp)
1117  0332 a30030        	cpw	x,#48
1118  0335 25ec          	jrult	L114
1119                     ; 225     SPI_CLK_LOW();
1121  0337 cd05a9        	call	_SPI_CLK_LOW
1123                     ; 226     SPI_CLK_LOW();
1125  033a cd05a9        	call	_SPI_CLK_LOW
1127                     ; 227     SPI_CLK_LOW();
1129  033d cd05a9        	call	_SPI_CLK_LOW
1131                     ; 228     SPI_CLK_LOW();
1133  0340 cd05a9        	call	_SPI_CLK_LOW
1135                     ; 229     SPI_CLK_LOW();
1137  0343 cd05a9        	call	_SPI_CLK_LOW
1139                     ; 231   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH(); //latching of 48 ones to the driver
1141  0346 4b08          	push	#8
1142  0348 ae500a        	ldw	x,#20490
1143  034b cd0000        	call	_GPIO_WriteHigh
1145  034e 84            	pop	a
1146                     ; 232     SPI_CLK_LOW();
1148  034f cd05a9        	call	_SPI_CLK_LOW
1150                     ; 233     SPI_CLK_LOW();
1152  0352 cd05a9        	call	_SPI_CLK_LOW
1154                     ; 234     SPI_CLK_LOW();
1156  0355 cd05a9        	call	_SPI_CLK_LOW
1158                     ; 237   GPIO_WriteLow(LE_PORT, LE_PIN);  //FAST_LE_low();
1160  0358 4b08          	push	#8
1161  035a ae500a        	ldw	x,#20490
1162  035d cd0000        	call	_GPIO_WriteLow
1164  0360 84            	pop	a
1165                     ; 238     SPI_CLK_LOW();
1167  0361 cd05a9        	call	_SPI_CLK_LOW
1169                     ; 239     SPI_CLK_LOW();
1171  0364 cd05a9        	call	_SPI_CLK_LOW
1173                     ; 240     SPI_CLK_LOW();
1175  0367 cd05a9        	call	_SPI_CLK_LOW
1177                     ; 244   GPIO_WriteLow(LE_PORT, LE_PIN); //FAST_LE_LOW();
1179  036a 4b08          	push	#8
1180  036c ae500a        	ldw	x,#20490
1181  036f cd0000        	call	_GPIO_WriteLow
1183  0372 84            	pop	a
1184                     ; 246   LED_driver_OutEnable_All_On(); //LED_driver_OutEnable(1); LED_driver_OutEnable(2);  //all the LED must be on for the test
1186  0373 cd046d        	call	_LED_driver_OutEnable_All_On
1188                     ; 247   SPI_CLK_HIGH();
1190  0376 cd05b3        	call	_SPI_CLK_HIGH
1192                     ; 248   SPI_CLK_LOW();
1194  0379 cd05a9        	call	_SPI_CLK_LOW
1196                     ; 249   SPI_CLK_HIGH();
1198  037c cd05b3        	call	_SPI_CLK_HIGH
1200                     ; 250   SPI_CLK_LOW();
1202  037f cd05a9        	call	_SPI_CLK_LOW
1204                     ; 253   for(i=0; i<10; i++)  
1206  0382 5f            	clrw	x
1207  0383 1f09          	ldw	(OFST-1,sp),x
1208  0385               L714:
1209                     ; 255       X = 10+i+y;    
1211  0385 1e01          	ldw	x,(OFST-9,sp)
1212  0387 1e09          	ldw	x,(OFST-1,sp)
1213  0389 72fb07        	addw	x,(OFST-3,sp)
1214  038c 1c000a        	addw	x,#10
1215                     ; 253   for(i=0; i<10; i++)  
1217  038f 1e09          	ldw	x,(OFST-1,sp)
1218  0391 1c0001        	addw	x,#1
1219  0394 1f09          	ldw	(OFST-1,sp),x
1222  0396 1e09          	ldw	x,(OFST-1,sp)
1223  0398 a3000a        	cpw	x,#10
1224  039b 25e8          	jrult	L714
1225                     ; 258   SPI_CLK_HIGH();
1227  039d cd05b3        	call	_SPI_CLK_HIGH
1229                     ; 259   SPI_CLK_LOW();
1231  03a0 cd05a9        	call	_SPI_CLK_LOW
1233                     ; 263   LED_driver_OutDisable_All_Off(); //LED_driver_OutDisable(1); LED_driver_OutDisable(2);  //end of the measurement on the LEDs
1235  03a3 cd04a4        	call	_LED_driver_OutDisable_All_Off
1237                     ; 265   SPI_Cmd(ENABLE);
1239  03a6 a601          	ld	a,#1
1240  03a8 cd0000        	call	_SPI_Cmd
1242                     ; 267   eFlag = 0;
1244  03ab 5f            	clrw	x
1245  03ac 1f03          	ldw	(OFST-7,sp),x
1246                     ; 268   DATAIN = SPI_ReceiveData();  //clear the input buffer flag
1248  03ae cd0000        	call	_SPI_ReceiveData
1250  03b1 b700          	ld	_DATAIN,a
1251                     ; 269   for(i = 0; i < (streamSizeToTest); i++){
1253  03b3 5f            	clrw	x
1254  03b4 1f09          	ldw	(OFST-1,sp),x
1256  03b6 2062          	jra	L134
1257  03b8               L524:
1258                     ; 270     SPI->DR =  0x00;
1260  03b8 725f5204      	clr	20996
1262  03bc               L144:
1263                     ; 271     while ((SPI->SR & SPI_SR_TXE) == 0);
1265  03bc c65203        	ld	a,20995
1266  03bf a502          	bcp	a,#2
1267  03c1 27f9          	jreq	L144
1269  03c3               L744:
1270                     ; 272 		while ((SPI->SR & SPI_SR_RXNE) == 0);
1272  03c3 c65203        	ld	a,20995
1273  03c6 a501          	bcp	a,#1
1274  03c8 27f9          	jreq	L744
1275                     ; 273     DATAIN = SPI->DR;
1277  03ca 5552040000    	mov	_DATAIN,20996
1278                     ; 274     for(y = 0; y<8; y++)
1280  03cf 5f            	clrw	x
1281  03d0 1f07          	ldw	(OFST-3,sp),x
1282  03d2               L354:
1283                     ; 275       if((DATAIN << y) & 0x80)
1285  03d2 b600          	ld	a,_DATAIN
1286  03d4 5f            	clrw	x
1287  03d5 97            	ld	xl,a
1288  03d6 7b08          	ld	a,(OFST-2,sp)
1289  03d8 4d            	tnz	a
1290  03d9 2704          	jreq	L22
1291  03db               L42:
1292  03db 58            	sllw	x
1293  03dc 4a            	dec	a
1294  03dd 26fc          	jrne	L42
1295  03df               L22:
1296  03df 01            	rrwa	x,a
1297  03e0 a580          	bcp	a,#128
1298  03e2 2710          	jreq	L164
1299                     ; 276         LEDmapIN[(i*8+y)] = 1;
1301  03e4 1e09          	ldw	x,(OFST-1,sp)
1302  03e6 58            	sllw	x
1303  03e7 58            	sllw	x
1304  03e8 58            	sllw	x
1305  03e9 72fb07        	addw	x,(OFST-3,sp)
1306  03ec 72fb0b        	addw	x,(OFST+1,sp)
1307  03ef a601          	ld	a,#1
1308  03f1 f7            	ld	(x),a
1310  03f2 2011          	jra	L364
1311  03f4               L164:
1312                     ; 278         LEDmapIN[(i*8+y)] = 0;
1314  03f4 1e09          	ldw	x,(OFST-1,sp)
1315  03f6 58            	sllw	x
1316  03f7 58            	sllw	x
1317  03f8 58            	sllw	x
1318  03f9 72fb07        	addw	x,(OFST-3,sp)
1319  03fc 72fb0b        	addw	x,(OFST+1,sp)
1320  03ff 7f            	clr	(x)
1321                     ; 279         eFlag = 1;        
1323  0400 ae0001        	ldw	x,#1
1324  0403 1f03          	ldw	(OFST-7,sp),x
1325  0405               L364:
1326                     ; 274     for(y = 0; y<8; y++)
1328  0405 1e07          	ldw	x,(OFST-3,sp)
1329  0407 1c0001        	addw	x,#1
1330  040a 1f07          	ldw	(OFST-3,sp),x
1333  040c 1e07          	ldw	x,(OFST-3,sp)
1334  040e a30008        	cpw	x,#8
1335  0411 25bf          	jrult	L354
1336                     ; 269   for(i = 0; i < (streamSizeToTest); i++){
1338  0413 1e09          	ldw	x,(OFST-1,sp)
1339  0415 1c0001        	addw	x,#1
1340  0418 1f09          	ldw	(OFST-1,sp),x
1341  041a               L134:
1344  041a 1e09          	ldw	x,(OFST-1,sp)
1345  041c 1305          	cpw	x,(OFST-5,sp)
1346  041e 2598          	jrult	L524
1347                     ; 283   GPIO_WriteHigh(LE_PORT, LE_PIN);  //FAST_LE_HIGH(); //new
1349  0420 4b08          	push	#8
1350  0422 ae500a        	ldw	x,#20490
1351  0425 cd0000        	call	_GPIO_WriteHigh
1353  0428 84            	pop	a
1354                     ; 284   GPIO_WriteLow(LE_PORT, LE_PIN); //FAST_LE_LOW(); //new
1356  0429 4b08          	push	#8
1357  042b ae500a        	ldw	x,#20490
1358  042e cd0000        	call	_GPIO_WriteLow
1360  0431 84            	pop	a
1361                     ; 286   SPI_Cmd(DISABLE);
1363  0432 4f            	clr	a
1364  0433 cd0000        	call	_SPI_Cmd
1366                     ; 289   SPI_CLK_HIGH();
1368  0436 cd05b3        	call	_SPI_CLK_HIGH
1370                     ; 290   SPI_CLK_LOW();
1372  0439 cd05a9        	call	_SPI_CLK_LOW
1374                     ; 291   SPI_CLK_HIGH();
1376  043c cd05b3        	call	_SPI_CLK_HIGH
1378                     ; 292   SPI_CLK_LOW();
1380  043f cd05a9        	call	_SPI_CLK_LOW
1382                     ; 293   LED_driver_OutEnable_All_On(); //LED_driver_OutEnable(1); LED_driver_OutEnable(2);
1384  0442 ad29          	call	_LED_driver_OutEnable_All_On
1386                     ; 294   SPI_CLK_HIGH();
1388  0444 cd05b3        	call	_SPI_CLK_HIGH
1390                     ; 295   SPI_CLK_LOW();
1392  0447 cd05a9        	call	_SPI_CLK_LOW
1394                     ; 296   LED_driver_OutDisable_All_Off(); //LED_driver_OutDisable(1); LED_driver_OutDisable(2);
1396  044a ad58          	call	_LED_driver_OutDisable_All_Off
1398                     ; 297   SPI_CLK_HIGH();
1400  044c cd05b3        	call	_SPI_CLK_HIGH
1402                     ; 298   SPI_CLK_LOW();
1404  044f cd05a9        	call	_SPI_CLK_LOW
1406                     ; 299   SPI_CLK_HIGH();
1408  0452 cd05b3        	call	_SPI_CLK_HIGH
1410                     ; 300   SPI_CLK_LOW();
1412  0455 cd05a9        	call	_SPI_CLK_LOW
1414                     ; 303   SPI_Cmd(ENABLE);
1416  0458 a601          	ld	a,#1
1417  045a cd0000        	call	_SPI_Cmd
1419                     ; 304   return eFlag;
1421  045d 7b04          	ld	a,(OFST-6,sp)
1424  045f 5b0c          	addw	sp,#12
1425  0461 81            	ret
1449                     ; 307 void start_dimmer(void){      //enable main interrupt and start sending data to SPI
1450                     	switch	.text
1451  0462               _start_dimmer:
1455                     ; 308   TIM1_Cmd(ENABLE);
1457  0462 a601          	ld	a,#1
1458  0464 cd0000        	call	_TIM1_Cmd
1460                     ; 309 }
1463  0467 81            	ret
1487                     ; 311 void stop_dimmer(void){       //disable main interrupt and stop sending data to SPI
1488                     	switch	.text
1489  0468               _stop_dimmer:
1493                     ; 312   TIM1_Cmd(DISABLE);
1495  0468 4f            	clr	a
1496  0469 cd0000        	call	_TIM1_Cmd
1498                     ; 313 }
1501  046c 81            	ret
1526                     ; 315 void LED_driver_OutEnable_All_On(void){   //enable OE
1527                     	switch	.text
1528  046d               _LED_driver_OutEnable_All_On:
1532                     ; 316   GPIO_WriteLow(OE1_PORT, OE1B_PIN); //Blue  OE1B
1534  046d 4b04          	push	#4
1535  046f ae5005        	ldw	x,#20485
1536  0472 cd0000        	call	_GPIO_WriteLow
1538  0475 84            	pop	a
1539                     ; 317   GPIO_WriteLow(OE1_PORT, OE1G_PIN); //Green OE1G
1541  0476 4b02          	push	#2
1542  0478 ae5005        	ldw	x,#20485
1543  047b cd0000        	call	_GPIO_WriteLow
1545  047e 84            	pop	a
1546                     ; 318   GPIO_WriteLow(OE1_PORT, OE1R_PIN); //Red   OE1R
1548  047f 4b01          	push	#1
1549  0481 ae5005        	ldw	x,#20485
1550  0484 cd0000        	call	_GPIO_WriteLow
1552  0487 84            	pop	a
1553                     ; 319   GPIO_WriteLow(OE2_PORT, OE2B_PIN); //Blue  OE2B
1555  0488 4b04          	push	#4
1556  048a ae500a        	ldw	x,#20490
1557  048d cd0000        	call	_GPIO_WriteLow
1559  0490 84            	pop	a
1560                     ; 320   GPIO_WriteLow(OE2_PORT, OE2G_PIN); //Green OE2G
1562  0491 4b02          	push	#2
1563  0493 ae500a        	ldw	x,#20490
1564  0496 cd0000        	call	_GPIO_WriteLow
1566  0499 84            	pop	a
1567                     ; 321   GPIO_WriteLow(OE2_PORT, OE2R_PIN); //Red   OE2R
1569  049a 4b01          	push	#1
1570  049c ae500a        	ldw	x,#20490
1571  049f cd0000        	call	_GPIO_WriteLow
1573  04a2 84            	pop	a
1574                     ; 322 }
1577  04a3 81            	ret
1602                     ; 324 void LED_driver_OutDisable_All_Off(void){   //disable signal OE
1603                     	switch	.text
1604  04a4               _LED_driver_OutDisable_All_Off:
1608                     ; 325   GPIO_WriteHigh(OE1_PORT, OE1B_PIN); //Blue  OE1B
1610  04a4 4b04          	push	#4
1611  04a6 ae5005        	ldw	x,#20485
1612  04a9 cd0000        	call	_GPIO_WriteHigh
1614  04ac 84            	pop	a
1615                     ; 326   GPIO_WriteHigh(OE1_PORT, OE1G_PIN); //Green OE1G
1617  04ad 4b02          	push	#2
1618  04af ae5005        	ldw	x,#20485
1619  04b2 cd0000        	call	_GPIO_WriteHigh
1621  04b5 84            	pop	a
1622                     ; 327   GPIO_WriteHigh(OE1_PORT, OE1R_PIN); //Red   OE1R
1624  04b6 4b01          	push	#1
1625  04b8 ae5005        	ldw	x,#20485
1626  04bb cd0000        	call	_GPIO_WriteHigh
1628  04be 84            	pop	a
1629                     ; 328   GPIO_WriteHigh(OE2_PORT, OE2B_PIN); //Blue  OE2B
1631  04bf 4b04          	push	#4
1632  04c1 ae500a        	ldw	x,#20490
1633  04c4 cd0000        	call	_GPIO_WriteHigh
1635  04c7 84            	pop	a
1636                     ; 329   GPIO_WriteHigh(OE2_PORT, OE2G_PIN); //Green OE2G
1638  04c8 4b02          	push	#2
1639  04ca ae500a        	ldw	x,#20490
1640  04cd cd0000        	call	_GPIO_WriteHigh
1642  04d0 84            	pop	a
1643                     ; 330   GPIO_WriteHigh(OE2_PORT, OE2R_PIN); //Red   OE2R
1645  04d1 4b01          	push	#1
1646  04d3 ae500a        	ldw	x,#20490
1647  04d6 cd0000        	call	_GPIO_WriteHigh
1649  04d9 84            	pop	a
1650                     ; 331 }
1653  04da 81            	ret
1698                     ; 333 void LED_driver_OutEnable(unsigned char which, unsigned char RGBchannel){   //enable OE
1699                     	switch	.text
1700  04db               _LED_driver_OutEnable:
1702  04db 89            	pushw	x
1703       00000000      OFST:	set	0
1706                     ; 334   if(which == 1)
1708  04dc 9e            	ld	a,xh
1709  04dd a101          	cp	a,#1
1710  04df 262c          	jrne	L745
1711                     ; 336     if(RGBchannel & 0x01) GPIO_WriteLow(OE1_PORT, OE1B_PIN); //Blue  OE1B
1713  04e1 9f            	ld	a,xl
1714  04e2 a501          	bcp	a,#1
1715  04e4 2709          	jreq	L155
1718  04e6 4b04          	push	#4
1719  04e8 ae5005        	ldw	x,#20485
1720  04eb cd0000        	call	_GPIO_WriteLow
1722  04ee 84            	pop	a
1723  04ef               L155:
1724                     ; 337     if(RGBchannel & 0x02) GPIO_WriteLow(OE1_PORT, OE1G_PIN); //Green OE1G
1726  04ef 7b02          	ld	a,(OFST+2,sp)
1727  04f1 a502          	bcp	a,#2
1728  04f3 2709          	jreq	L355
1731  04f5 4b02          	push	#2
1732  04f7 ae5005        	ldw	x,#20485
1733  04fa cd0000        	call	_GPIO_WriteLow
1735  04fd 84            	pop	a
1736  04fe               L355:
1737                     ; 338     if(RGBchannel & 0x04) GPIO_WriteLow(OE1_PORT, OE1R_PIN); //Red   OE1R
1739  04fe 7b02          	ld	a,(OFST+2,sp)
1740  0500 a504          	bcp	a,#4
1741  0502 2709          	jreq	L745
1744  0504 4b01          	push	#1
1745  0506 ae5005        	ldw	x,#20485
1746  0509 cd0000        	call	_GPIO_WriteLow
1748  050c 84            	pop	a
1749  050d               L745:
1750                     ; 340   if(which == 2)
1752  050d 7b01          	ld	a,(OFST+1,sp)
1753  050f a102          	cp	a,#2
1754  0511 262d          	jrne	L755
1755                     ; 342     if(RGBchannel & 0x01) GPIO_WriteLow(OE2_PORT, OE2B_PIN); //Blue  OE2B
1757  0513 7b02          	ld	a,(OFST+2,sp)
1758  0515 a501          	bcp	a,#1
1759  0517 2709          	jreq	L165
1762  0519 4b04          	push	#4
1763  051b ae500a        	ldw	x,#20490
1764  051e cd0000        	call	_GPIO_WriteLow
1766  0521 84            	pop	a
1767  0522               L165:
1768                     ; 343     if(RGBchannel & 0x02) GPIO_WriteLow(OE2_PORT, OE2G_PIN);  //Green OE2G
1770  0522 7b02          	ld	a,(OFST+2,sp)
1771  0524 a502          	bcp	a,#2
1772  0526 2709          	jreq	L365
1775  0528 4b02          	push	#2
1776  052a ae500a        	ldw	x,#20490
1777  052d cd0000        	call	_GPIO_WriteLow
1779  0530 84            	pop	a
1780  0531               L365:
1781                     ; 344     if(RGBchannel & 0x04) GPIO_WriteLow(OE2_PORT, OE2R_PIN);  //Red   OE2R
1783  0531 7b02          	ld	a,(OFST+2,sp)
1784  0533 a504          	bcp	a,#4
1785  0535 2709          	jreq	L755
1788  0537 4b01          	push	#1
1789  0539 ae500a        	ldw	x,#20490
1790  053c cd0000        	call	_GPIO_WriteLow
1792  053f 84            	pop	a
1793  0540               L755:
1794                     ; 346 }
1797  0540 85            	popw	x
1798  0541 81            	ret
1843                     ; 348 void LED_driver_OutDisable(unsigned char which, unsigned char RGBchannel){   //disable signal OE
1844                     	switch	.text
1845  0542               _LED_driver_OutDisable:
1847  0542 89            	pushw	x
1848       00000000      OFST:	set	0
1851                     ; 349   if(which == 1)
1853  0543 9e            	ld	a,xh
1854  0544 a101          	cp	a,#1
1855  0546 262c          	jrne	L116
1856                     ; 351     if(RGBchannel & 0x01) GPIO_WriteHigh(OE1_PORT, OE1B_PIN); //Blue  OE1B
1858  0548 9f            	ld	a,xl
1859  0549 a501          	bcp	a,#1
1860  054b 2709          	jreq	L316
1863  054d 4b04          	push	#4
1864  054f ae5005        	ldw	x,#20485
1865  0552 cd0000        	call	_GPIO_WriteHigh
1867  0555 84            	pop	a
1868  0556               L316:
1869                     ; 352     if(RGBchannel & 0x02) GPIO_WriteHigh(OE1_PORT, OE1G_PIN); //Green OE1G
1871  0556 7b02          	ld	a,(OFST+2,sp)
1872  0558 a502          	bcp	a,#2
1873  055a 2709          	jreq	L516
1876  055c 4b02          	push	#2
1877  055e ae5005        	ldw	x,#20485
1878  0561 cd0000        	call	_GPIO_WriteHigh
1880  0564 84            	pop	a
1881  0565               L516:
1882                     ; 353     if(RGBchannel & 0x04) GPIO_WriteHigh(OE1_PORT, OE1R_PIN); //Red   OE1R
1884  0565 7b02          	ld	a,(OFST+2,sp)
1885  0567 a504          	bcp	a,#4
1886  0569 2709          	jreq	L116
1889  056b 4b01          	push	#1
1890  056d ae5005        	ldw	x,#20485
1891  0570 cd0000        	call	_GPIO_WriteHigh
1893  0573 84            	pop	a
1894  0574               L116:
1895                     ; 355   if(which == 2)
1897  0574 7b01          	ld	a,(OFST+1,sp)
1898  0576 a102          	cp	a,#2
1899  0578 262d          	jrne	L126
1900                     ; 357     if(RGBchannel & 0x01) GPIO_WriteHigh(OE2_PORT, OE2B_PIN); //Blue  OE2B
1902  057a 7b02          	ld	a,(OFST+2,sp)
1903  057c a501          	bcp	a,#1
1904  057e 2709          	jreq	L326
1907  0580 4b04          	push	#4
1908  0582 ae500a        	ldw	x,#20490
1909  0585 cd0000        	call	_GPIO_WriteHigh
1911  0588 84            	pop	a
1912  0589               L326:
1913                     ; 358     if(RGBchannel & 0x02) GPIO_WriteHigh(OE2_PORT, OE2G_PIN);  //Green OE2G
1915  0589 7b02          	ld	a,(OFST+2,sp)
1916  058b a502          	bcp	a,#2
1917  058d 2709          	jreq	L526
1920  058f 4b02          	push	#2
1921  0591 ae500a        	ldw	x,#20490
1922  0594 cd0000        	call	_GPIO_WriteHigh
1924  0597 84            	pop	a
1925  0598               L526:
1926                     ; 359     if(RGBchannel & 0x04) GPIO_WriteHigh(OE2_PORT, OE2R_PIN);  //Red   OE2R
1928  0598 7b02          	ld	a,(OFST+2,sp)
1929  059a a504          	bcp	a,#4
1930  059c 2709          	jreq	L126
1933  059e 4b01          	push	#1
1934  05a0 ae500a        	ldw	x,#20490
1935  05a3 cd0000        	call	_GPIO_WriteHigh
1937  05a6 84            	pop	a
1938  05a7               L126:
1939                     ; 361 }
1942  05a7 85            	popw	x
1943  05a8 81            	ret
1967                     ; 363 void SPI_CLK_LOW(void){
1968                     	switch	.text
1969  05a9               _SPI_CLK_LOW:
1973                     ; 364   GPIO_WriteLow(SPI_PORT, SPI_CLK_PIN);
1975  05a9 4b20          	push	#32
1976  05ab ae500a        	ldw	x,#20490
1977  05ae cd0000        	call	_GPIO_WriteLow
1979  05b1 84            	pop	a
1980                     ; 365 }
1983  05b2 81            	ret
2007                     ; 367 void SPI_CLK_HIGH(void){
2008                     	switch	.text
2009  05b3               _SPI_CLK_HIGH:
2013                     ; 368   GPIO_WriteHigh(SPI_PORT, SPI_CLK_PIN);
2015  05b3 4b20          	push	#32
2016  05b5 ae500a        	ldw	x,#20490
2017  05b8 cd0000        	call	_GPIO_WriteHigh
2019  05bb 84            	pop	a
2020                     ; 369 }
2023  05bc 81            	ret
2085                     ; 371 void use_new_table_immediately(unsigned char *table, unsigned char *tableKey, int table_size){ //exchange table(SPI data) not preventing glitch,
2086                     	switch	.text
2087  05bd               _use_new_table_immediately:
2089  05bd 89            	pushw	x
2090       00000000      OFST:	set	0
2093                     ; 372   released_table_start     = actual_table_start;
2095  05be be13          	ldw	x,_actual_table_start
2096  05c0 bf07          	ldw	_released_table_start,x
2097                     ; 373   released_table_key_start = actual_table_key_start;
2099  05c2 be11          	ldw	x,_actual_table_key_start
2100  05c4 bf05          	ldw	_released_table_key_start,x
2101                     ; 374   released_table_size      = actual_table_size;
2103  05c6 be0f          	ldw	x,_actual_table_size
2104  05c8 bf03          	ldw	_released_table_size,x
2105                     ; 376   actual_table_start     = table;
2107  05ca 1e01          	ldw	x,(OFST+1,sp)
2108  05cc bf13          	ldw	_actual_table_start,x
2109                     ; 377   actual_table_key_start = tableKey;
2111  05ce 1e05          	ldw	x,(OFST+5,sp)
2112  05d0 bf11          	ldw	_actual_table_key_start,x
2113                     ; 378   actual_table_size      = table_size;
2115  05d2 1e07          	ldw	x,(OFST+7,sp)
2116  05d4 bf0f          	ldw	_actual_table_size,x
2117                     ; 380   new_table_not_changed_yet_flag = 0;
2119  05d6 5f            	clrw	x
2120  05d7 bf01          	ldw	_new_table_not_changed_yet_flag,x
2121                     ; 381 }
2124  05d9 85            	popw	x
2125  05da 81            	ret
2190                     ; 383 void use_new_table_carefully(unsigned char *table, unsigned char *tableKey, int table_size){
2191                     	switch	.text
2192  05db               _use_new_table_carefully:
2194  05db 89            	pushw	x
2195       00000000      OFST:	set	0
2198                     ; 384   new_table_not_changed_yet_flag = 1; //exchange table(SPI data) preventing glitch, in right time
2200  05dc ae0001        	ldw	x,#1
2201  05df bf01          	ldw	_new_table_not_changed_yet_flag,x
2202                     ; 386   released_table_start     = actual_table_start;
2204  05e1 be13          	ldw	x,_actual_table_start
2205  05e3 bf07          	ldw	_released_table_start,x
2206                     ; 387   released_table_key_start = actual_table_key_start;
2208  05e5 be11          	ldw	x,_actual_table_key_start
2209  05e7 bf05          	ldw	_released_table_key_start,x
2210                     ; 388   released_table_size      = actual_table_size;
2212  05e9 be0f          	ldw	x,_actual_table_size
2213  05eb bf03          	ldw	_released_table_size,x
2214                     ; 390   new_table_start     = table;
2216  05ed 1e01          	ldw	x,(OFST+1,sp)
2217  05ef bf0d          	ldw	_new_table_start,x
2218                     ; 391   new_table_key_start = tableKey;
2220  05f1 1e05          	ldw	x,(OFST+5,sp)
2221  05f3 bf0b          	ldw	_new_table_key_start,x
2222                     ; 392   new_table_size      = table_size;
2224  05f5 1e07          	ldw	x,(OFST+7,sp)
2225  05f7 bf09          	ldw	_new_table_size,x
2226                     ; 393 }
2229  05f9 85            	popw	x
2230  05fa 81            	ret
2255                     ; 395 int new_table_not_changed_yet(void){ //true till right time for table not reached
2256                     	switch	.text
2257  05fb               _new_table_not_changed_yet:
2261                     ; 396   return new_table_not_changed_yet_flag;
2263  05fb be01          	ldw	x,_new_table_not_changed_yet_flag
2266  05fd 81            	ret
2353                     ; 399 int generateReducedLookUpTable(unsigned char *LEDmapIN, int LEDcount, int PWMdepth, unsigned char **tableIN, unsigned char **tableKeyIN, int *table_sizeIN){
2354                     	switch	.text
2355  05fe               _generateReducedLookUpTable:
2357  05fe 89            	pushw	x
2358       00000000      OFST:	set	0
2361                     ; 402   performGenerateReducedLookUpTable(LEDmapIN, LEDcount, PWMdepth, tableIN, tableKeyIN, table_sizeIN);
2363  05ff 1e0d          	ldw	x,(OFST+13,sp)
2364  0601 89            	pushw	x
2365  0602 1e0d          	ldw	x,(OFST+13,sp)
2366  0604 89            	pushw	x
2367  0605 1e0d          	ldw	x,(OFST+13,sp)
2368  0607 89            	pushw	x
2369  0608 1e0d          	ldw	x,(OFST+13,sp)
2370  060a 89            	pushw	x
2371  060b 1e0d          	ldw	x,(OFST+13,sp)
2372  060d 89            	pushw	x
2373  060e 1e0b          	ldw	x,(OFST+11,sp)
2374  0610 cd0000        	call	_performGenerateReducedLookUpTable
2376  0613 5b0a          	addw	sp,#10
2377                     ; 404   if((*tableIN)&&(*tableKeyIN))
2379  0615 1e09          	ldw	x,(OFST+9,sp)
2380  0617 e601          	ld	a,(1,x)
2381  0619 fa            	or	a,(x)
2382  061a 270c          	jreq	L777
2384  061c 1e0b          	ldw	x,(OFST+11,sp)
2385  061e e601          	ld	a,(1,x)
2386  0620 fa            	or	a,(x)
2387  0621 2705          	jreq	L777
2388                     ; 405     return SUCCESS;
2390  0623 ae0001        	ldw	x,#1
2392  0626 2001          	jra	L65
2393  0628               L777:
2394                     ; 407     return ERROR;
2396  0628 5f            	clrw	x
2398  0629               L65:
2400  0629 5b02          	addw	sp,#2
2401  062b 81            	ret
2427                     ; 410 void removeLookUpTableInUse(void){
2428                     	switch	.text
2429  062c               _removeLookUpTableInUse:
2433                     ; 411   if(actual_table_start)
2435  062c be13          	ldw	x,_actual_table_start
2436  062e 2705          	jreq	L3101
2437                     ; 412     free(actual_table_start);
2439  0630 be13          	ldw	x,_actual_table_start
2440  0632 cd0000        	call	_free
2442  0635               L3101:
2443                     ; 413   if(actual_table_start)
2445  0635 be13          	ldw	x,_actual_table_start
2446  0637 2705          	jreq	L5101
2447                     ; 414     free(actual_table_start);
2449  0639 be13          	ldw	x,_actual_table_start
2450  063b cd0000        	call	_free
2452  063e               L5101:
2453                     ; 415 }
2456  063e 81            	ret
2483                     ; 417 void removeLookUpTableReleased(void){
2484                     	switch	.text
2485  063f               _removeLookUpTableReleased:
2489                     ; 418   if(released_table_start)
2491  063f be07          	ldw	x,_released_table_start
2492  0641 2705          	jreq	L7201
2493                     ; 419     free(released_table_start);
2495  0643 be07          	ldw	x,_released_table_start
2496  0645 cd0000        	call	_free
2498  0648               L7201:
2499                     ; 420   if(released_table_key_start)
2501  0648 be05          	ldw	x,_released_table_key_start
2502  064a 2705          	jreq	L1301
2503                     ; 421     free(released_table_key_start);
2505  064c be05          	ldw	x,_released_table_key_start
2506  064e cd0000        	call	_free
2508  0651               L1301:
2509                     ; 422 }
2512  0651 81            	ret
2542                     ; 424 void RCC_Configuration(void)
2542                     ; 425 {
2543                     	switch	.text
2544  0652               _RCC_Configuration:
2548                     ; 426 CLK_DeInit();
2550  0652 cd0000        	call	_CLK_DeInit
2552                     ; 427 CLK_HSICmd(ENABLE);
2554  0655 a601          	ld	a,#1
2555  0657 cd0000        	call	_CLK_HSICmd
2557                     ; 428 CLK_HSIPrescalerConfig(CLK_PRESCALER_HSIDIV1);
2559  065a 4f            	clr	a
2560  065b cd0000        	call	_CLK_HSIPrescalerConfig
2562                     ; 429 CLK_SYSCLKConfig(CLK_PRESCALER_CPUDIV1);
2564  065e a680          	ld	a,#128
2565  0660 cd0000        	call	_CLK_SYSCLKConfig
2567                     ; 430 CLK_ClockSwitchConfig(CLK_SWITCHMODE_MANUAL, CLK_SOURCE_HSI, DISABLE, CLK_CURRENTCLOCKSTATE_ENABLE);
2569  0663 4b01          	push	#1
2570  0665 4b00          	push	#0
2571  0667 ae00e1        	ldw	x,#225
2572  066a 4f            	clr	a
2573  066b 95            	ld	xh,a
2574  066c cd0000        	call	_CLK_ClockSwitchConfig
2576  066f 85            	popw	x
2577                     ; 433 CLK_ClockSwitchCmd(ENABLE);
2579  0670 a601          	ld	a,#1
2580  0672 cd0000        	call	_CLK_ClockSwitchCmd
2582                     ; 435 CLK_CCOConfig(CLK_OUTPUT_CPU);
2584  0675 a608          	ld	a,#8
2585  0677 cd0000        	call	_CLK_CCOConfig
2587                     ; 436 }
2590  067a 81            	ret
2613                     ; 438 void NVIC_Configuration(void)
2613                     ; 439 {
2614                     	switch	.text
2615  067b               _NVIC_Configuration:
2619                     ; 440 }
2622  067b 81            	ret
2650                     ; 448 void SPI_GPIO_Init(void)
2650                     ; 449 {
2651                     	switch	.text
2652  067c               _SPI_GPIO_Init:
2656                     ; 451   GPIO_WriteHigh(GPIOB, OE1B_PIN);  
2658  067c 4b04          	push	#4
2659  067e ae5005        	ldw	x,#20485
2660  0681 cd0000        	call	_GPIO_WriteHigh
2662  0684 84            	pop	a
2663                     ; 452 	GPIO_WriteHigh(GPIOB, OE1G_PIN);
2665  0685 4b02          	push	#2
2666  0687 ae5005        	ldw	x,#20485
2667  068a cd0000        	call	_GPIO_WriteHigh
2669  068d 84            	pop	a
2670                     ; 453   GPIO_WriteHigh(GPIOB, OE1R_PIN);  
2672  068e 4b01          	push	#1
2673  0690 ae5005        	ldw	x,#20485
2674  0693 cd0000        	call	_GPIO_WriteHigh
2676  0696 84            	pop	a
2677                     ; 454   GPIO_WriteHigh(GPIOB, DM_PIN);
2679  0697 4b08          	push	#8
2680  0699 ae5005        	ldw	x,#20485
2681  069c cd0000        	call	_GPIO_WriteHigh
2683  069f 84            	pop	a
2684                     ; 455   GPIO_Init(GPIOB, (OE1B_PIN | OE1G_PIN | OE1R_PIN | DM_PIN), GPIO_MODE_OUT_PP_HIGH_FAST);
2686  06a0 4bd0          	push	#208
2687  06a2 4b0f          	push	#15
2688  06a4 ae5005        	ldw	x,#20485
2689  06a7 cd0000        	call	_GPIO_Init
2691  06aa 85            	popw	x
2692                     ; 456   GPIO_WriteHigh(GPIOB, OE1B_PIN);  
2694  06ab 4b04          	push	#4
2695  06ad ae5005        	ldw	x,#20485
2696  06b0 cd0000        	call	_GPIO_WriteHigh
2698  06b3 84            	pop	a
2699                     ; 457 	GPIO_WriteHigh(GPIOB, OE1G_PIN);
2701  06b4 4b02          	push	#2
2702  06b6 ae5005        	ldw	x,#20485
2703  06b9 cd0000        	call	_GPIO_WriteHigh
2705  06bc 84            	pop	a
2706                     ; 458   GPIO_WriteHigh(GPIOB, OE1R_PIN);  
2708  06bd 4b01          	push	#1
2709  06bf ae5005        	ldw	x,#20485
2710  06c2 cd0000        	call	_GPIO_WriteHigh
2712  06c5 84            	pop	a
2713                     ; 459   GPIO_WriteHigh(GPIOB, DM_PIN);
2715  06c6 4b08          	push	#8
2716  06c8 ae5005        	ldw	x,#20485
2717  06cb cd0000        	call	_GPIO_WriteHigh
2719  06ce 84            	pop	a
2720                     ; 461   GPIO_WriteHigh(GPIOC, OE2B_PIN);
2722  06cf 4b04          	push	#4
2723  06d1 ae500a        	ldw	x,#20490
2724  06d4 cd0000        	call	_GPIO_WriteHigh
2726  06d7 84            	pop	a
2727                     ; 462   GPIO_WriteHigh(GPIOC, OE2G_PIN);  
2729  06d8 4b02          	push	#2
2730  06da ae500a        	ldw	x,#20490
2731  06dd cd0000        	call	_GPIO_WriteHigh
2733  06e0 84            	pop	a
2734                     ; 463 	GPIO_WriteHigh(GPIOC, OE2R_PIN);
2736  06e1 4b01          	push	#1
2737  06e3 ae500a        	ldw	x,#20490
2738  06e6 cd0000        	call	_GPIO_WriteHigh
2740  06e9 84            	pop	a
2741                     ; 464   GPIO_WriteHigh(GPIOC, LE_PIN);
2743  06ea 4b08          	push	#8
2744  06ec ae500a        	ldw	x,#20490
2745  06ef cd0000        	call	_GPIO_WriteHigh
2747  06f2 84            	pop	a
2748                     ; 465   GPIO_Init(GPIOC, (OE2B_PIN | OE2G_PIN | OE2R_PIN | LE_PIN 
2748                     ; 466 	                | SPI_CLK_PIN | SPI_MOSI_PIN), GPIO_MODE_OUT_PP_HIGH_FAST);
2750  06f3 4bd0          	push	#208
2751  06f5 4b6f          	push	#111
2752  06f7 ae500a        	ldw	x,#20490
2753  06fa cd0000        	call	_GPIO_Init
2755  06fd 85            	popw	x
2756                     ; 467   GPIO_Init(GPIOC, (SPI_MISO_PIN), GPIO_MODE_IN_FL_NO_IT);
2758  06fe 4b00          	push	#0
2759  0700 4b80          	push	#128
2760  0702 ae500a        	ldw	x,#20490
2761  0705 cd0000        	call	_GPIO_Init
2763  0708 85            	popw	x
2764                     ; 468   GPIO_WriteHigh(GPIOC, OE2B_PIN);
2766  0709 4b04          	push	#4
2767  070b ae500a        	ldw	x,#20490
2768  070e cd0000        	call	_GPIO_WriteHigh
2770  0711 84            	pop	a
2771                     ; 469   GPIO_WriteHigh(GPIOC, OE2G_PIN);  
2773  0712 4b02          	push	#2
2774  0714 ae500a        	ldw	x,#20490
2775  0717 cd0000        	call	_GPIO_WriteHigh
2777  071a 84            	pop	a
2778                     ; 470 	GPIO_WriteHigh(GPIOC, OE2R_PIN);
2780  071b 4b01          	push	#1
2781  071d ae500a        	ldw	x,#20490
2782  0720 cd0000        	call	_GPIO_WriteHigh
2784  0723 84            	pop	a
2785                     ; 471   GPIO_WriteHigh(GPIOC, LE_PIN);
2787  0724 4b08          	push	#8
2788  0726 ae500a        	ldw	x,#20490
2789  0729 cd0000        	call	_GPIO_WriteHigh
2791  072c 84            	pop	a
2792                     ; 474   SPI_DeInit();
2794  072d cd0000        	call	_SPI_DeInit
2796                     ; 475   SPI_Init(SPI_FIRSTBIT_MSB, SPI_BAUDRATEPRESCALER_2, SPI_MODE_MASTER,
2796                     ; 476 	         SPI_CLOCKPOLARITY_HIGH, SPI_CLOCKPHASE_2EDGE, SPI_DATADIRECTION_2LINES_FULLDUPLEX,
2796                     ; 477 					 SPI_NSS_SOFT, 0x07);
2798  0730 4b07          	push	#7
2799  0732 4b02          	push	#2
2800  0734 4b00          	push	#0
2801  0736 4b01          	push	#1
2802  0738 4b02          	push	#2
2803  073a 4b04          	push	#4
2804  073c 5f            	clrw	x
2805  073d 4f            	clr	a
2806  073e 95            	ld	xh,a
2807  073f cd0000        	call	_SPI_Init
2809  0742 5b06          	addw	sp,#6
2810                     ; 478 	SPI_Cmd(ENABLE);	
2812  0744 a601          	ld	a,#1
2813  0746 cd0000        	call	_SPI_Cmd
2815                     ; 479 }
2818  0749 81            	ret
2962                     	switch	.ubsct
2963  0000               _DATAIN:
2964  0000 00            	ds.b	1
2965                     	xdef	_DATAIN
2966  0001               _new_table_not_changed_yet_flag:
2967  0001 0000          	ds.b	2
2968                     	xdef	_new_table_not_changed_yet_flag
2969  0003               _released_table_size:
2970  0003 0000          	ds.b	2
2971                     	xdef	_released_table_size
2972  0005               _released_table_key_start:
2973  0005 0000          	ds.b	2
2974                     	xdef	_released_table_key_start
2975  0007               _released_table_start:
2976  0007 0000          	ds.b	2
2977                     	xdef	_released_table_start
2978  0009               _new_table_size:
2979  0009 0000          	ds.b	2
2980                     	xdef	_new_table_size
2981  000b               _new_table_key_start:
2982  000b 0000          	ds.b	2
2983                     	xdef	_new_table_key_start
2984  000d               _new_table_start:
2985  000d 0000          	ds.b	2
2986                     	xdef	_new_table_start
2987  000f               _actual_table_size:
2988  000f 0000          	ds.b	2
2989                     	xdef	_actual_table_size
2990  0011               _actual_table_key_start:
2991  0011 0000          	ds.b	2
2992                     	xdef	_actual_table_key_start
2993  0013               _actual_table_start:
2994  0013 0000          	ds.b	2
2995                     	xdef	_actual_table_start
2996  0015               _actual_PWMdepth:
2997  0015 0000          	ds.b	2
2998                     	xdef	_actual_PWMdepth
2999                     	xdef	_actual_streamSize
3000                     	xref	_performGenerateReducedLookUpTable
3001                     	xref	_free
3002                     	xdef	_SPI_GPIO_Init
3003                     	xdef	_NVIC_Configuration
3004                     	xdef	_RCC_Configuration
3005                     	xdef	_fillDriver
3006                     	xdef	_removeLookUpTableReleased
3007                     	xdef	_removeLookUpTableInUse
3008                     	xdef	_generateReducedLookUpTable
3009                     	xdef	_new_table_not_changed_yet
3010                     	xdef	_use_new_table_carefully
3011                     	xdef	_use_new_table_immediately
3012                     	xdef	_SPI_CLK_HIGH
3013                     	xdef	_SPI_CLK_LOW
3014                     	xdef	_LED_driver_OutDisable_All_Off
3015                     	xdef	_LED_driver_OutEnable_All_On
3016                     	xdef	_LED_driver_OutDisable
3017                     	xdef	_LED_driver_OutEnable
3018                     	xdef	_stop_dimmer
3019                     	xdef	_start_dimmer
3020                     	xdef	_error_detection_LE_OE
3021                     	xdef	_error_detection_DMX
3022                     	xdef	_setup
3023                     	xref	_TIM1_ITConfig
3024                     	xref	_TIM1_Cmd
3025                     	xref	_TIM1_TimeBaseInit
3026                     	xref	_SPI_ReceiveData
3027                     	xref	_SPI_Cmd
3028                     	xref	_SPI_Init
3029                     	xref	_SPI_DeInit
3030                     	xref	_GPIO_WriteLow
3031                     	xref	_GPIO_WriteHigh
3032                     	xref	_GPIO_Init
3033                     	xref	_CLK_SYSCLKConfig
3034                     	xref	_CLK_CCOConfig
3035                     	xref	_CLK_HSIPrescalerConfig
3036                     	xref	_CLK_ClockSwitchConfig
3037                     	xref	_CLK_ClockSwitchCmd
3038                     	xref	_CLK_HSICmd
3039                     	xref	_CLK_DeInit
3040                     .const:	section	.text
3041  0000               L751:
3042  0000 3f800000      	dc.w	16256,0
3043  0004               L741:
3044  0004 358637bd      	dc.w	13702,14269
3045  0008               L721:
3046  0008 3d6147ae      	dc.w	15713,18350
3047  000c               L731:
3048  000c 40100000      	dc.w	16400,0
3049                     	xref.b	c_lreg
3069                     	xref	c_ldiv
3070                     	xref	c_itolx
3071                     	xref	c_imul
3072                     	xref	c_fcmp
3073                     	xref	c_fdiv
3074                     	xref	c_ltor
3075                     	xref	c_rtol
3076                     	xref	c_fadd
3077                     	xref	c_fmul
3078                     	xref	c_itof
3079                     	xref	c_sdivx
3080                     	end
