/******************** (C) COPYRIGHT 2007 STMicroelectronics ********************
* File Name          : led_demonstration.h
* Author             : EMMA team Prague
* Date First Issued  : 30/01/2008
* Description        : 
********************************************************************************
* History:
* 30/01/2008: V0.0
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __BOARD_CONTROL_H
#define __BOARD_CONTROL_H

//#define _IAR_BOARD
#define _ST_BOARD

#define ButtonLeftRight_Port (GPIOB)
#define ButtonLeft_Pin (GPIO_PIN_4)
#define ButtonRight_Pin (GPIO_PIN_5)
#define ButtonSelect_Port (GPIOD)
#define ButtonSelect_Pin (GPIO_PIN_7)
#define ADC_Port (GPIOE)
#define ADC_Pin (GPIO_PIN_6)

#define EXTI_PORT_ButtonLeftRight EXTI_PORT_GPIOB
#define EXTI_PORT_ButtonSelect EXTI_PORT_GPIOD

unsigned char buttonKnob(void);

struct buttonsAndADC
{
  unsigned char buttonLeft;
  unsigned char buttonRight;
  unsigned char buttonCenter;
  unsigned char (*buttonKnob)(void);
};

void BC_ADC_Configuration(void);
void BC_GPIO_Configuration(void);
void BC_EXTI_Configuration(void);

#endif
