   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
   3                     ; Optimizer V4.2.4 - 18 Dec 2007
  33                     ; 61 void SPI_DeInit(void)
  33                     ; 62 {
  35                     	switch	.text
  36  0000               _SPI_DeInit:
  40                     ; 63   SPI->CR1    = SPI_CR1_RESET_VALUE;
  42  0000 725f5200      	clr	20992
  43                     ; 64   SPI->CR2    = SPI_CR2_RESET_VALUE;
  45  0004 725f5201      	clr	20993
  46                     ; 65   SPI->ICR    = SPI_ICR_RESET_VALUE;
  48  0008 725f5202      	clr	20994
  49                     ; 66   SPI->SR     = SPI_SR_RESET_VALUE;
  51  000c 35025203      	mov	20995,#2
  52                     ; 67   SPI->CRCPR  = SPI_CRCPR_RESET_VALUE;
  54  0010 35075205      	mov	20997,#7
  55                     ; 68 }
  58  0014 81            	ret	
 374                     ; 90 void SPI_Init(SPI_FirstBit_TypeDef FirstBit, SPI_BaudRatePrescaler_TypeDef BaudRatePrescaler, SPI_Mode_TypeDef Mode, SPI_ClockPolarity_TypeDef ClockPolarity, SPI_ClockPhase_TypeDef ClockPhase, SPI_DataDirection_TypeDef Data_Direction, SPI_NSS_TypeDef Slave_Management, u8 CRCPolynomial)
 374                     ; 91 {
 375                     	switch	.text
 376  0015               _SPI_Init:
 378  0015 89            	pushw	x
 379       00000000      OFST:	set	0
 382                     ; 93   assert_param(IS_SPI_FIRSTBIT_OK(FirstBit));
 384                     ; 94   assert_param(IS_SPI_BAUDRATE_PRESCALER_OK(BaudRatePrescaler));
 386                     ; 95   assert_param(IS_SPI_MODE_OK(Mode));
 388                     ; 96   assert_param(IS_SPI_POLARITY_OK(ClockPolarity));
 390                     ; 97   assert_param(IS_SPI_PHASE_OK(ClockPhase));
 392                     ; 98   assert_param(IS_SPI_DATA_DIRECTION_OK(Data_Direction));
 394                     ; 99   assert_param(IS_SPI_SLAVEMANAGEMENT_OK(Slave_Management));
 396                     ; 100   assert_param(IS_SPI_CRC_POLYNOMIAL_OK(CRCPolynomial));
 398                     ; 103   SPI->CR1 = (u8)((u8)(FirstBit) |
 398                     ; 104                   (u8)(BaudRatePrescaler) |
 398                     ; 105                   (u8)(ClockPolarity) |
 398                     ; 106                   (u8)(ClockPhase));
 400  0016 9f            	ld	a,xl
 401  0017 1a01          	or	a,(OFST+1,sp)
 402  0019 1a06          	or	a,(OFST+6,sp)
 403  001b 1a07          	or	a,(OFST+7,sp)
 404  001d c75200        	ld	20992,a
 405                     ; 109   SPI->CR2 = (u8)((u8)(Data_Direction) | (u8)(Slave_Management));
 407  0020 7b08          	ld	a,(OFST+8,sp)
 408  0022 1a09          	or	a,(OFST+9,sp)
 409  0024 c75201        	ld	20993,a
 410                     ; 111   if (Mode == SPI_MODE_MASTER)
 412  0027 7b05          	ld	a,(OFST+5,sp)
 413  0029 a104          	cp	a,#4
 414  002b 2606          	jrne	L302
 415                     ; 113     SPI->CR2 |= (u8)SPI_CR2_SSI;
 417  002d 72105201      	bset	20993,#0
 419  0031 2004          	jra	L502
 420  0033               L302:
 421                     ; 117     SPI->CR2 &= (u8)~(SPI_CR2_SSI);
 423  0033 72115201      	bres	20993,#0
 424  0037               L502:
 425                     ; 121   SPI->CR1 |= (u8)(Mode);
 427  0037 c65200        	ld	a,20992
 428  003a 1a05          	or	a,(OFST+5,sp)
 429  003c c75200        	ld	20992,a
 430                     ; 124   SPI->CRCPR = (u8)CRCPolynomial;
 432  003f 7b0a          	ld	a,(OFST+10,sp)
 433  0041 c75205        	ld	20997,a
 434                     ; 125 }
 437  0044 85            	popw	x
 438  0045 81            	ret	
 493                     ; 143 void SPI_Cmd(FunctionalState NewState)
 493                     ; 144 {
 494                     	switch	.text
 495  0046               _SPI_Cmd:
 499                     ; 146   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 501                     ; 148   if (NewState != DISABLE)
 503  0046 4d            	tnz	a
 504  0047 2705          	jreq	L532
 505                     ; 150     SPI->CR1 |= SPI_CR1_SPE; /* Enable the SPI peripheral*/
 507  0049 721c5200      	bset	20992,#6
 510  004d 81            	ret	
 511  004e               L532:
 512                     ; 154     SPI->CR1 &= (u8)(~SPI_CR1_SPE); /* Disable the SPI peripheral*/
 514  004e 721d5200      	bres	20992,#6
 515                     ; 156 }
 518  0052 81            	ret	
 627                     ; 174 void SPI_ITConfig(SPI_IT_TypeDef SPI_IT, FunctionalState NewState)
 627                     ; 175 {
 628                     	switch	.text
 629  0053               _SPI_ITConfig:
 631  0053 89            	pushw	x
 632  0054 88            	push	a
 633       00000001      OFST:	set	1
 636                     ; 176   u8 itpos = 0;
 638  0055 0f01          	clr	(OFST+0,sp)
 639                     ; 178   assert_param(IS_SPI_CONFIG_IT_OK(SPI_IT));
 641                     ; 179   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 643                     ; 182   itpos = (u8)((u8)1 << (u8)((u8)SPI_IT & (u8)0x0F));
 645  0057 9e            	ld	a,xh
 646  0058 a40f          	and	a,#15
 647  005a 5f            	clrw	x
 648  005b 97            	ld	xl,a
 649  005c a601          	ld	a,#1
 650  005e 5d            	tnzw	x
 651  005f 2704          	jreq	L41
 652  0061               L61:
 653  0061 48            	sll	a
 654  0062 5a            	decw	x
 655  0063 26fc          	jrne	L61
 656  0065               L41:
 657  0065 6b01          	ld	(OFST+0,sp),a
 658                     ; 184   if (NewState != DISABLE)
 660  0067 0d03          	tnz	(OFST+2,sp)
 661  0069 2707          	jreq	L113
 662                     ; 186     SPI->ICR |= itpos; /* Enable interrupt*/
 664  006b c65202        	ld	a,20994
 665  006e 1a01          	or	a,(OFST+0,sp)
 667  0070 2004          	jra	L313
 668  0072               L113:
 669                     ; 190     SPI->ICR &= (u8)(~itpos); /* Disable interrupt*/
 671  0072 43            	cpl	a
 672  0073 c45202        	and	a,20994
 673  0076               L313:
 674  0076 c75202        	ld	20994,a
 675                     ; 192 }
 678  0079 5b03          	addw	sp,#3
 679  007b 81            	ret	
 713                     ; 206 void SPI_SendData(u8 Data)
 713                     ; 207 {
 714                     	switch	.text
 715  007c               _SPI_SendData:
 719                     ; 208   SPI->DR = Data; /* Write in the DR register the data to be sent*/
 721  007c c75204        	ld	20996,a
 722                     ; 209 }
 725  007f 81            	ret	
 748                     ; 225 u8 SPI_ReceiveData(void)
 748                     ; 226 {
 749                     	switch	.text
 750  0080               _SPI_ReceiveData:
 754                     ; 227   return ((u8)SPI->DR); /* Return the data in the DR register*/
 756  0080 c65204        	ld	a,20996
 759  0083 81            	ret	
 795                     ; 246 void SPI_NSSInternalSoftwareCmd(FunctionalState NewState)
 795                     ; 247 {
 796                     	switch	.text
 797  0084               _SPI_NSSInternalSoftwareCmd:
 801                     ; 249   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 803                     ; 251   if (NewState != DISABLE)
 805  0084 4d            	tnz	a
 806  0085 2705          	jreq	L163
 807                     ; 253     SPI->CR2 |= SPI_CR2_SSI; /* Set NSS pin internally by software*/
 809  0087 72105201      	bset	20993,#0
 812  008b 81            	ret	
 813  008c               L163:
 814                     ; 257     SPI->CR2 &= (u8)(~SPI_CR2_SSI); /* Reset NSS pin internally by software*/
 816  008c 72115201      	bres	20993,#0
 817                     ; 259 }
 820  0090 81            	ret	
 843                     ; 275 void SPI_TransmitCRC(void)
 843                     ; 276 {
 844                     	switch	.text
 845  0091               _SPI_TransmitCRC:
 849                     ; 277   SPI->CR2 |= SPI_CR2_CRCNEXT; /* Enable the CRC transmission*/
 851  0091 72185201      	bset	20993,#4
 852                     ; 278 }
 855  0095 81            	ret	
 892                     ; 295 void SPI_CalculateCRCCmd(FunctionalState NewState)
 892                     ; 296 {
 893                     	switch	.text
 894  0096               _SPI_CalculateCRCCmd:
 896  0096 88            	push	a
 897       00000000      OFST:	set	0
 900                     ; 298   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 902                     ; 301   SPI_Cmd(DISABLE);
 904  0097 4f            	clr	a
 905  0098 adac          	call	_SPI_Cmd
 907                     ; 303   if (NewState != DISABLE)
 909  009a 7b01          	ld	a,(OFST+1,sp)
 910  009c 2706          	jreq	L314
 911                     ; 305     SPI->CR2 |= SPI_CR2_CRCEN; /* Enable the CRC calculation*/
 913  009e 721a5201      	bset	20993,#5
 915  00a2 2004          	jra	L514
 916  00a4               L314:
 917                     ; 309     SPI->CR2 &= (u8)(~SPI_CR2_CRCEN); /* Disable the CRC calculation*/
 919  00a4 721b5201      	bres	20993,#5
 920  00a8               L514:
 921                     ; 311 }
 924  00a8 84            	pop	a
 925  00a9 81            	ret	
 989                     ; 326 u8 SPI_GetCRC(SPI_CRC_TypeDef SPI_CRC)
 989                     ; 327 {
 990                     	switch	.text
 991  00aa               _SPI_GetCRC:
 993  00aa 88            	push	a
 994       00000001      OFST:	set	1
 997                     ; 328   u8 crcreg = 0;
 999  00ab 0f01          	clr	(OFST+0,sp)
1000                     ; 331   assert_param(IS_SPI_CRC_OK(SPI_CRC));
1002                     ; 333   if (SPI_CRC != SPI_CRC_RX)
1004  00ad 4d            	tnz	a
1005  00ae 2705          	jreq	L154
1006                     ; 335     crcreg = SPI->TXCRCR;  /* Get the Tx CRC register*/
1008  00b0 c65207        	ld	a,20999
1010  00b3 2003          	jra	L354
1011  00b5               L154:
1012                     ; 339     crcreg = SPI->RXCRCR; /* Get the Rx CRC register*/
1014  00b5 c65206        	ld	a,20998
1015  00b8               L354:
1016                     ; 343   return crcreg;
1020  00b8 5b01          	addw	sp,#1
1021  00ba 81            	ret	
1046                     ; 359 void SPI_ResetCRC(void)
1046                     ; 360 {
1047                     	switch	.text
1048  00bb               _SPI_ResetCRC:
1052                     ; 363   SPI_CalculateCRCCmd(ENABLE);
1054  00bb a601          	ld	a,#1
1055  00bd add7          	call	_SPI_CalculateCRCCmd
1057                     ; 366   SPI_Cmd(ENABLE);
1059  00bf a601          	ld	a,#1
1061                     ; 367 }
1064  00c1 2083          	jp	_SPI_Cmd
1088                     ; 384 u8 SPI_GetCRCPolynomial(void)
1088                     ; 385 {
1089                     	switch	.text
1090  00c3               _SPI_GetCRCPolynomial:
1094                     ; 386   return SPI->CRCPR; /* Return the CRC polynomial register */
1096  00c3 c65205        	ld	a,20997
1099  00c6 81            	ret	
1155                     ; 402 void SPI_BiDirectionalLineConfig(SPI_Direction_TypeDef SPI_Direction)
1155                     ; 403 {
1156                     	switch	.text
1157  00c7               _SPI_BiDirectionalLineConfig:
1161                     ; 405   assert_param(IS_SPI_DIRECTION_OK(SPI_Direction));
1163                     ; 407   if (SPI_Direction != SPI_DIRECTION_RX)
1165  00c7 4d            	tnz	a
1166  00c8 2705          	jreq	L325
1167                     ; 409     SPI->CR2 |= SPI_CR2_BIDIOE; /* Set the Tx only mode*/
1169  00ca 721c5201      	bset	20993,#6
1172  00ce 81            	ret	
1173  00cf               L325:
1174                     ; 413     SPI->CR2 &= (u8)(~SPI_CR2_BIDIOE); /* Set the Rx only mode*/
1176  00cf 721d5201      	bres	20993,#6
1177                     ; 415 }
1180  00d3 81            	ret	
1301                     ; 435 FlagStatus SPI_GetFlagStatus(SPI_Flag_TypeDef SPI_FLAG)
1301                     ; 436 {
1302                     	switch	.text
1303  00d4               _SPI_GetFlagStatus:
1305  00d4 88            	push	a
1306       00000001      OFST:	set	1
1309                     ; 437   FlagStatus status = RESET;
1311  00d5 0f01          	clr	(OFST+0,sp)
1312                     ; 439   assert_param(IS_SPI_FLAGS_OK(SPI_FLAG));
1314                     ; 442   if ((SPI->SR & (u8)SPI_FLAG) != (u8)RESET)
1316  00d7 c45203        	and	a,20995
1317  00da 2702          	jreq	L306
1318                     ; 444     status = SET; /* SPI_FLAG is set */
1320  00dc a601          	ld	a,#1
1322  00de               L306:
1323                     ; 448     status = RESET; /* SPI_FLAG is reset*/
1325                     ; 452   return status;
1329  00de 5b01          	addw	sp,#1
1330  00e0 81            	ret	
1365                     ; 479 void SPI_ClearFlag(SPI_Flag_TypeDef SPI_FLAG)
1365                     ; 480 {
1366                     	switch	.text
1367  00e1               _SPI_ClearFlag:
1371                     ; 481   assert_param(IS_SPI_CLEAR_FLAGS_OK(SPI_FLAG));
1373                     ; 483   SPI->SR = (u8)(~SPI_FLAG);
1375  00e1 43            	cpl	a
1376  00e2 c75203        	ld	20995,a
1377                     ; 484 }
1380  00e5 81            	ret	
1462                     ; 509 ITStatus SPI_GetITStatus(SPI_IT_TypeDef SPI_IT)
1462                     ; 510 {
1463                     	switch	.text
1464  00e6               _SPI_GetITStatus:
1466  00e6 88            	push	a
1467  00e7 89            	pushw	x
1468       00000002      OFST:	set	2
1471                     ; 511   ITStatus pendingbitstatus = RESET;
1473                     ; 512   u8 itpos = 0;
1475                     ; 513   u8 itmask1 = 0;
1477                     ; 514   u8 itmask2 = 0;
1479                     ; 515   u8 enablestatus = 0;
1481                     ; 516   assert_param(IS_SPI_GET_IT_OK(SPI_IT));
1483                     ; 518   itpos = (u8)((u8)1 << ((u8)SPI_IT & (u8)0x0F));
1485  00e8 7b03          	ld	a,(OFST+1,sp)
1486  00ea a40f          	and	a,#15
1487  00ec 5f            	clrw	x
1488  00ed 97            	ld	xl,a
1489  00ee a601          	ld	a,#1
1490  00f0 5d            	tnzw	x
1491  00f1 2704          	jreq	L65
1492  00f3               L06:
1493  00f3 48            	sll	a
1494  00f4 5a            	decw	x
1495  00f5 26fc          	jrne	L06
1496  00f7               L65:
1497  00f7 6b01          	ld	(OFST-1,sp),a
1498                     ; 521   itmask1 = (u8)((u8)SPI_IT >> (u8)4);
1500  00f9 7b03          	ld	a,(OFST+1,sp)
1501  00fb 4e            	swap	a
1502  00fc a40f          	and	a,#15
1503  00fe 6b02          	ld	(OFST+0,sp),a
1504                     ; 523   itmask2 = (u8)((u8)1 << itmask1);
1506  0100 5f            	clrw	x
1507  0101 97            	ld	xl,a
1508  0102 a601          	ld	a,#1
1509  0104 5d            	tnzw	x
1510  0105 2704          	jreq	L26
1511  0107               L46:
1512  0107 48            	sll	a
1513  0108 5a            	decw	x
1514  0109 26fc          	jrne	L46
1515  010b               L26:
1516                     ; 525   enablestatus = (u8)((u8)SPI->ICR & itmask2);
1518  010b c45202        	and	a,20994
1519  010e 6b02          	ld	(OFST+0,sp),a
1520                     ; 527   if (((SPI->SR & itpos) != RESET) && enablestatus)
1522  0110 c65203        	ld	a,20995
1523  0113 1501          	bcp	a,(OFST-1,sp)
1524  0115 2708          	jreq	L766
1526  0117 7b02          	ld	a,(OFST+0,sp)
1527  0119 2704          	jreq	L766
1528                     ; 530     pendingbitstatus = SET;
1530  011b a601          	ld	a,#1
1532  011d 2001          	jra	L176
1533  011f               L766:
1534                     ; 535     pendingbitstatus = RESET;
1536  011f 4f            	clr	a
1537  0120               L176:
1538                     ; 538   return  pendingbitstatus;
1542  0120 5b03          	addw	sp,#3
1543  0122 81            	ret	
1588                     ; 564 void SPI_ClearITPendingBit(SPI_IT_TypeDef SPI_IT)
1588                     ; 565 {
1589                     	switch	.text
1590  0123               _SPI_ClearITPendingBit:
1592  0123 88            	push	a
1593       00000001      OFST:	set	1
1596                     ; 566   u8 itpos = 0;
1598  0124 0f01          	clr	(OFST+0,sp)
1599                     ; 567   assert_param(IS_SPI_CLEAR_IT_OK(SPI_IT));
1601                     ; 572   itpos = (u8)((u8)1 << (((u8)SPI_IT & (u8)0xF0) >> 4));
1603  0126 4e            	swap	a
1604  0127 a40f          	and	a,#15
1605  0129 5f            	clrw	x
1606  012a 97            	ld	xl,a
1607  012b a601          	ld	a,#1
1608  012d 5d            	tnzw	x
1609  012e 2704          	jreq	L07
1610  0130               L27:
1611  0130 48            	sll	a
1612  0131 5a            	decw	x
1613  0132 26fc          	jrne	L27
1614  0134               L07:
1615                     ; 574   SPI->SR = (u8)(~itpos);
1617  0134 43            	cpl	a
1618  0135 c75203        	ld	20995,a
1619                     ; 576 }
1622  0138 84            	pop	a
1623  0139 81            	ret	
1636                     	xdef	_SPI_ClearITPendingBit
1637                     	xdef	_SPI_GetITStatus
1638                     	xdef	_SPI_ClearFlag
1639                     	xdef	_SPI_GetFlagStatus
1640                     	xdef	_SPI_BiDirectionalLineConfig
1641                     	xdef	_SPI_GetCRCPolynomial
1642                     	xdef	_SPI_ResetCRC
1643                     	xdef	_SPI_GetCRC
1644                     	xdef	_SPI_CalculateCRCCmd
1645                     	xdef	_SPI_TransmitCRC
1646                     	xdef	_SPI_NSSInternalSoftwareCmd
1647                     	xdef	_SPI_ReceiveData
1648                     	xdef	_SPI_SendData
1649                     	xdef	_SPI_ITConfig
1650                     	xdef	_SPI_Cmd
1651                     	xdef	_SPI_Init
1652                     	xdef	_SPI_DeInit
1671                     	end
