   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
  32                     ; 65 void ADC_DeInit(void)
  32                     ; 66 {
  34                     	switch	.text
  35  0000               _ADC_DeInit:
  39                     ; 67   ADC->CSR  = ADC_CSR_RESET_VALUE;
  41  0000 725f5400      	clr	21504
  42                     ; 68   ADC->CR1  = ADC_CR1_RESET_VALUE;
  44  0004 725f5401      	clr	21505
  45                     ; 69   ADC->CR2  = ADC_CR2_RESET_VALUE;
  47  0008 725f5402      	clr	21506
  48                     ; 70   ADC->CR3  = ADC_CR3_RESET_VALUE;
  50  000c 725f5403      	clr	21507
  51                     ; 71   ADC->TDRH = ADC_TDRH_RESET_VALUE;
  53  0010 725f5406      	clr	21510
  54                     ; 72   ADC->TDRL = ADC_TDRL_RESET_VALUE;
  56  0014 725f5407      	clr	21511
  57                     ; 73   ADC->VRHM = ADC_VRHM_RESET_VALUE;
  59  0018 35ff5408      	mov	21512,#255
  60                     ; 74   ADC->VRHL = ADC_VRHL_RESET_VALUE;
  62  001c 35035409      	mov	21513,#3
  63                     ; 75   ADC->VRLM = ADC_VRLM_RESET_VALUE;
  65  0020 725f540a      	clr	21514
  66                     ; 76   ADC->VRLL = ADC_VRLL_RESET_VALUE;
  68  0024 725f540b      	clr	21515
  69                     ; 77   ADC->AWENH = ADC_AWENH_RESET_VALUE;
  71  0028 725f540e      	clr	21518
  72                     ; 78   ADC->AWENL = ADC_AWENL_RESET_VALUE;
  74  002c 725f540f      	clr	21519
  75                     ; 79 }
  78  0030 81            	ret
 602                     ; 115 void ADC_Init(ADC_ConvMode_TypeDef ADC_ConversionMode, ADC_Channel_TypeDef ADC_Channel, ADC_PresSel_TypeDef ADC_PrescalerSelection, ADC_ExtTrig_TypeDef ADC_ExtTrigger, FunctionalState ADC_ExtTrigState, ADC_Align_TypeDef ADC_Align, ADC_SchmittTrigg_TypeDef ADC_SchmittTriggerChannel, FunctionalState ADC_SchmittTriggerState)
 602                     ; 116 {
 603                     	switch	.text
 604  0031               _ADC_Init:
 606  0031 89            	pushw	x
 607       00000000      OFST:	set	0
 610                     ; 119   assert_param(IS_ADC_CONVERSIONMODE_OK(ADC_ConversionMode));
 612                     ; 120   assert_param(IS_ADC_CHANNEL_OK(ADC_Channel));
 614                     ; 121   assert_param(IS_ADC_PRESSEL_OK(ADC_PrescalerSelection));
 616                     ; 122   assert_param(IS_ADC_EXTTRIG_OK(ADC_ExtTrigger));
 618                     ; 123   assert_param(IS_FUNCTIONALSTATE_OK(((ADC_ExtTrigState))));
 620                     ; 124   assert_param(IS_ADC_ALIGN_OK(ADC_Align));
 622                     ; 125   assert_param(IS_ADC_SCHMITTTRIG_OK(ADC_SchmittTriggerChannel));
 624                     ; 126   assert_param(IS_FUNCTIONALSTATE_OK(ADC_SchmittTriggerState));
 626                     ; 131   ADC_ConversionConfig(ADC_ConversionMode, ADC_Channel, ADC_Align);
 628  0032 7b08          	ld	a,(OFST+8,sp)
 629  0034 88            	push	a
 630  0035 9f            	ld	a,xl
 631  0036 97            	ld	xl,a
 632  0037 7b02          	ld	a,(OFST+2,sp)
 633  0039 95            	ld	xh,a
 634  003a cd013d        	call	_ADC_ConversionConfig
 636  003d 84            	pop	a
 637                     ; 133   ADC_PrescalerConfig(ADC_PrescalerSelection);
 639  003e 7b05          	ld	a,(OFST+5,sp)
 640  0040 ad5a          	call	_ADC_PrescalerConfig
 642                     ; 138   ADC_ExternalTriggerConfig(ADC_ExtTrigger, ADC_ExtTrigState);
 644  0042 7b07          	ld	a,(OFST+7,sp)
 645  0044 97            	ld	xl,a
 646  0045 7b06          	ld	a,(OFST+6,sp)
 647  0047 95            	ld	xh,a
 648  0048 cd016b        	call	_ADC_ExternalTriggerConfig
 650                     ; 143   ADC_SchmittTriggerConfig(ADC_SchmittTriggerChannel, ADC_SchmittTriggerState);
 652  004b 7b0a          	ld	a,(OFST+10,sp)
 653  004d 97            	ld	xl,a
 654  004e 7b09          	ld	a,(OFST+9,sp)
 655  0050 95            	ld	xh,a
 656  0051 ad5c          	call	_ADC_SchmittTriggerConfig
 658                     ; 146   ADC->CR1 |= ADC_CR1_ADON;
 660  0053 72105401      	bset	21505,#0
 661                     ; 148 }
 664  0057 85            	popw	x
 665  0058 81            	ret
 700                     ; 165 void ADC_Cmd(FunctionalState NewState)
 700                     ; 166 {
 701                     	switch	.text
 702  0059               _ADC_Cmd:
 706                     ; 169   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 708                     ; 171   if (NewState != DISABLE)
 710  0059 4d            	tnz	a
 711  005a 2706          	jreq	L703
 712                     ; 173     ADC->CR1 |= ADC_CR1_ADON;
 714  005c 72105401      	bset	21505,#0
 716  0060 2004          	jra	L113
 717  0062               L703:
 718                     ; 177     ADC->CR1 &= (u8)(~ADC_CR1_ADON);
 720  0062 72115401      	bres	21505,#0
 721  0066               L113:
 722                     ; 180 }
 725  0066 81            	ret
 760                     ; 196 void ADC_ScanModeCmd(FunctionalState NewState)
 760                     ; 197 {
 761                     	switch	.text
 762  0067               _ADC_ScanModeCmd:
 766                     ; 200   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 768                     ; 202   if (NewState != DISABLE)
 770  0067 4d            	tnz	a
 771  0068 2706          	jreq	L133
 772                     ; 204     ADC->CR2 |= ADC_CR2_SCAN;
 774  006a 72125402      	bset	21506,#1
 776  006e 2004          	jra	L333
 777  0070               L133:
 778                     ; 208     ADC->CR2 &= (u8)(~ADC_CR2_SCAN);
 780  0070 72135402      	bres	21506,#1
 781  0074               L333:
 782                     ; 211 }
 785  0074 81            	ret
 820                     ; 227 void ADC_DataBufferCmd(FunctionalState NewState)
 820                     ; 228 {
 821                     	switch	.text
 822  0075               _ADC_DataBufferCmd:
 826                     ; 231   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 828                     ; 233   if (NewState != DISABLE)
 830  0075 4d            	tnz	a
 831  0076 2706          	jreq	L353
 832                     ; 235     ADC->CR3 |= ADC_CR3_DBUF;
 834  0078 721e5403      	bset	21507,#7
 836  007c 2004          	jra	L553
 837  007e               L353:
 838                     ; 239     ADC->CR3 &= (u8)(~ADC_CR3_DBUF);
 840  007e 721f5403      	bres	21507,#7
 841  0082               L553:
 842                     ; 242 }
 845  0082 81            	ret
 994                     ; 262 void ADC_ITConfig(ADC_IT_TypeDef ADC_IT, FunctionalState ADC_ITEnable)
 994                     ; 263 {
 995                     	switch	.text
 996  0083               _ADC_ITConfig:
 998  0083 89            	pushw	x
 999       00000000      OFST:	set	0
1002                     ; 266   assert_param(IS_ADC_IT_OK(ADC_IT));
1004                     ; 267   assert_param(IS_FUNCTIONALSTATE_OK(ADC_ITEnable));
1006                     ; 269   if (ADC_ITEnable != DISABLE)
1008  0084 9f            	ld	a,xl
1009  0085 4d            	tnz	a
1010  0086 2709          	jreq	L144
1011                     ; 272     ADC->CSR |= ADC_IT;
1013  0088 9e            	ld	a,xh
1014  0089 ca5400        	or	a,21504
1015  008c c75400        	ld	21504,a
1017  008f 2009          	jra	L344
1018  0091               L144:
1019                     ; 277     ADC->CSR &= (u8)(~ADC_IT);
1021  0091 7b01          	ld	a,(OFST+1,sp)
1022  0093 43            	cpl	a
1023  0094 c45400        	and	a,21504
1024  0097 c75400        	ld	21504,a
1025  009a               L344:
1026                     ; 280 }
1029  009a 85            	popw	x
1030  009b 81            	ret
1066                     ; 297 void ADC_PrescalerConfig(ADC_PresSel_TypeDef ADC_Prescaler)
1066                     ; 298 {
1067                     	switch	.text
1068  009c               _ADC_PrescalerConfig:
1070  009c 88            	push	a
1071       00000000      OFST:	set	0
1074                     ; 301   assert_param(IS_ADC_PRESSEL_OK(ADC_Prescaler));
1076                     ; 304   ADC->CR1 &= (u8)(~ADC_CR1_SPSEL);
1078  009d c65401        	ld	a,21505
1079  00a0 a48f          	and	a,#143
1080  00a2 c75401        	ld	21505,a
1081                     ; 306   ADC->CR1 |= (u8)(ADC_Prescaler);
1083  00a5 c65401        	ld	a,21505
1084  00a8 1a01          	or	a,(OFST+1,sp)
1085  00aa c75401        	ld	21505,a
1086                     ; 308 }
1089  00ad 84            	pop	a
1090  00ae 81            	ret
1138                     ; 328 void ADC_SchmittTriggerConfig(ADC_SchmittTrigg_TypeDef ADC_SchmittTriggerChannel, FunctionalState ADC_SchmittTriggerState)
1138                     ; 329 {
1139                     	switch	.text
1140  00af               _ADC_SchmittTriggerConfig:
1142  00af 89            	pushw	x
1143       00000000      OFST:	set	0
1146                     ; 332   assert_param(IS_ADC_SCHMITTTRIG_OK(ADC_SchmittTriggerChannel));
1148                     ; 333   assert_param(IS_FUNCTIONALSTATE_OK(ADC_SchmittTriggerState));
1150                     ; 335   if (ADC_SchmittTriggerChannel == ADC_SCHMITTTRIG_ALL)
1152  00b0 9e            	ld	a,xh
1153  00b1 a11f          	cp	a,#31
1154  00b3 2620          	jrne	L505
1155                     ; 337     if (ADC_SchmittTriggerState != DISABLE)
1157  00b5 9f            	ld	a,xl
1158  00b6 4d            	tnz	a
1159  00b7 270a          	jreq	L705
1160                     ; 339       ADC->TDRL &= (u8)0x0;
1162  00b9 725f5407      	clr	21511
1163                     ; 340       ADC->TDRH &= (u8)0x0;
1165  00bd 725f5406      	clr	21510
1167  00c1 2078          	jra	L315
1168  00c3               L705:
1169                     ; 344       ADC->TDRL |= (u8)0xFF;
1171  00c3 c65407        	ld	a,21511
1172  00c6 aaff          	or	a,#255
1173  00c8 c75407        	ld	21511,a
1174                     ; 345       ADC->TDRH |= (u8)0xFF;
1176  00cb c65406        	ld	a,21510
1177  00ce aaff          	or	a,#255
1178  00d0 c75406        	ld	21510,a
1179  00d3 2066          	jra	L315
1180  00d5               L505:
1181                     ; 348   else if (ADC_SchmittTriggerChannel < ADC_SCHMITTTRIG_CHANNEL8)
1183  00d5 7b01          	ld	a,(OFST+1,sp)
1184  00d7 a108          	cp	a,#8
1185  00d9 242f          	jruge	L515
1186                     ; 350     if (ADC_SchmittTriggerState != DISABLE)
1188  00db 0d02          	tnz	(OFST+2,sp)
1189  00dd 2716          	jreq	L715
1190                     ; 352       ADC->TDRL &= (u8)(~(u8)((u8)0x01 << (u8)ADC_SchmittTriggerChannel));
1192  00df 7b01          	ld	a,(OFST+1,sp)
1193  00e1 5f            	clrw	x
1194  00e2 97            	ld	xl,a
1195  00e3 a601          	ld	a,#1
1196  00e5 5d            	tnzw	x
1197  00e6 2704          	jreq	L42
1198  00e8               L62:
1199  00e8 48            	sll	a
1200  00e9 5a            	decw	x
1201  00ea 26fc          	jrne	L62
1202  00ec               L42:
1203  00ec 43            	cpl	a
1204  00ed c45407        	and	a,21511
1205  00f0 c75407        	ld	21511,a
1207  00f3 2046          	jra	L315
1208  00f5               L715:
1209                     ; 356       ADC->TDRL |= (u8)((u8)0x01 << (u8)ADC_SchmittTriggerChannel);
1211  00f5 7b01          	ld	a,(OFST+1,sp)
1212  00f7 5f            	clrw	x
1213  00f8 97            	ld	xl,a
1214  00f9 a601          	ld	a,#1
1215  00fb 5d            	tnzw	x
1216  00fc 2704          	jreq	L03
1217  00fe               L23:
1218  00fe 48            	sll	a
1219  00ff 5a            	decw	x
1220  0100 26fc          	jrne	L23
1221  0102               L03:
1222  0102 ca5407        	or	a,21511
1223  0105 c75407        	ld	21511,a
1224  0108 2031          	jra	L315
1225  010a               L515:
1226                     ; 361     if (ADC_SchmittTriggerState != DISABLE)
1228  010a 0d02          	tnz	(OFST+2,sp)
1229  010c 2718          	jreq	L525
1230                     ; 363       ADC->TDRH &= (u8)(~(u8)((u8)0x01 << ((u8)ADC_SchmittTriggerChannel - (u8)8)));
1232  010e 7b01          	ld	a,(OFST+1,sp)
1233  0110 a008          	sub	a,#8
1234  0112 5f            	clrw	x
1235  0113 97            	ld	xl,a
1236  0114 a601          	ld	a,#1
1237  0116 5d            	tnzw	x
1238  0117 2704          	jreq	L43
1239  0119               L63:
1240  0119 48            	sll	a
1241  011a 5a            	decw	x
1242  011b 26fc          	jrne	L63
1243  011d               L43:
1244  011d 43            	cpl	a
1245  011e c45406        	and	a,21510
1246  0121 c75406        	ld	21510,a
1248  0124 2015          	jra	L315
1249  0126               L525:
1250                     ; 367       ADC->TDRH |= (u8)((u8)0x01 << ((u8)ADC_SchmittTriggerChannel - (u8)8));
1252  0126 7b01          	ld	a,(OFST+1,sp)
1253  0128 a008          	sub	a,#8
1254  012a 5f            	clrw	x
1255  012b 97            	ld	xl,a
1256  012c a601          	ld	a,#1
1257  012e 5d            	tnzw	x
1258  012f 2704          	jreq	L04
1259  0131               L24:
1260  0131 48            	sll	a
1261  0132 5a            	decw	x
1262  0133 26fc          	jrne	L24
1263  0135               L04:
1264  0135 ca5406        	or	a,21510
1265  0138 c75406        	ld	21510,a
1266  013b               L315:
1267                     ; 371 }
1270  013b 85            	popw	x
1271  013c 81            	ret
1327                     ; 393 void ADC_ConversionConfig(ADC_ConvMode_TypeDef ADC_ConversionMode, ADC_Channel_TypeDef ADC_Channel, ADC_Align_TypeDef ADC_Align)
1327                     ; 394 {
1328                     	switch	.text
1329  013d               _ADC_ConversionConfig:
1331  013d 89            	pushw	x
1332       00000000      OFST:	set	0
1335                     ; 397   assert_param(IS_ADC_CONVERSIONMODE_OK(ADC_ConversionMode));
1337                     ; 398   assert_param(IS_ADC_CHANNEL_OK(ADC_Channel));
1339                     ; 399   assert_param(IS_ADC_ALIGN_OK(ADC_Align));
1341                     ; 402   ADC->CR2 &= (u8)(~ADC_CR2_ALIGN);
1343  013e 72175402      	bres	21506,#3
1344                     ; 404   ADC->CR2 |= (u8)(ADC_Align);
1346  0142 c65402        	ld	a,21506
1347  0145 1a05          	or	a,(OFST+5,sp)
1348  0147 c75402        	ld	21506,a
1349                     ; 406   if (ADC_ConversionMode == ADC_CONVERSIONMODE_CONTINUOUS)
1351  014a 9e            	ld	a,xh
1352  014b a101          	cp	a,#1
1353  014d 2606          	jrne	L755
1354                     ; 409     ADC->CR1 |= ADC_CR1_CONT;
1356  014f 72125401      	bset	21505,#1
1358  0153 2004          	jra	L165
1359  0155               L755:
1360                     ; 414     ADC->CR1 &= (u8)(~ADC_CR1_CONT);
1362  0155 72135401      	bres	21505,#1
1363  0159               L165:
1364                     ; 418   ADC->CSR &= (u8)(~ADC_CSR_CH);
1366  0159 c65400        	ld	a,21504
1367  015c a4f0          	and	a,#240
1368  015e c75400        	ld	21504,a
1369                     ; 420   ADC->CSR |= (u8)(ADC_Channel);
1371  0161 c65400        	ld	a,21504
1372  0164 1a02          	or	a,(OFST+2,sp)
1373  0166 c75400        	ld	21504,a
1374                     ; 422 }
1377  0169 85            	popw	x
1378  016a 81            	ret
1424                     ; 444 void ADC_ExternalTriggerConfig(ADC_ExtTrig_TypeDef ADC_ExtTrigger, FunctionalState ADC_ExtTrigState)
1424                     ; 445 {
1425                     	switch	.text
1426  016b               _ADC_ExternalTriggerConfig:
1428  016b 89            	pushw	x
1429       00000000      OFST:	set	0
1432                     ; 448   assert_param(IS_ADC_EXTTRIG_OK(ADC_ExtTrigger));
1434                     ; 449   assert_param(IS_FUNCTIONALSTATE_OK(ADC_ExtTrigState));
1436                     ; 452   ADC->CR2 &= (u8)(~ADC_CR2_EXTSEL);
1438  016c c65402        	ld	a,21506
1439  016f a4cf          	and	a,#207
1440  0171 c75402        	ld	21506,a
1441                     ; 454   if (ADC_ExtTrigState != DISABLE)
1443  0174 9f            	ld	a,xl
1444  0175 4d            	tnz	a
1445  0176 2706          	jreq	L506
1446                     ; 457     ADC->CR2 |= (u8)(ADC_CR2_EXTTRIG);
1448  0178 721c5402      	bset	21506,#6
1450  017c 2004          	jra	L706
1451  017e               L506:
1452                     ; 462     ADC->CR2 &= (u8)(~ADC_CR2_EXTTRIG);
1454  017e 721d5402      	bres	21506,#6
1455  0182               L706:
1456                     ; 466   ADC->CR2 |= (u8)(ADC_ExtTrigger);
1458  0182 c65402        	ld	a,21506
1459  0185 1a01          	or	a,(OFST+1,sp)
1460  0187 c75402        	ld	21506,a
1461                     ; 468 }
1464  018a 85            	popw	x
1465  018b 81            	ret
1489                     ; 488 void ADC_StartConversion(void)
1489                     ; 489 {
1490                     	switch	.text
1491  018c               _ADC_StartConversion:
1495                     ; 490   ADC->CR1 |= ADC_CR1_ADON;
1497  018c 72105401      	bset	21505,#0
1498                     ; 491 }
1501  0190 81            	ret
1545                     ; 509 u16 ADC_GetConversionValue(void)
1545                     ; 510 {
1546                     	switch	.text
1547  0191               _ADC_GetConversionValue:
1549  0191 5205          	subw	sp,#5
1550       00000005      OFST:	set	5
1553                     ; 512   u16 temph = 0;
1555  0193 1e04          	ldw	x,(OFST-1,sp)
1556                     ; 513   u8 templ = 0;
1558  0195 7b03          	ld	a,(OFST-2,sp)
1559  0197 97            	ld	xl,a
1560                     ; 515   if (ADC->CR2 & ADC_CR2_ALIGN) /* Right alignment */
1562  0198 c65402        	ld	a,21506
1563  019b a508          	bcp	a,#8
1564  019d 2719          	jreq	L346
1565                     ; 518     templ = ADC->DRL;
1567  019f c65405        	ld	a,21509
1568  01a2 6b03          	ld	(OFST-2,sp),a
1569                     ; 520     temph = ADC->DRH;
1571  01a4 c65404        	ld	a,21508
1572  01a7 5f            	clrw	x
1573  01a8 97            	ld	xl,a
1574  01a9 1f04          	ldw	(OFST-1,sp),x
1575                     ; 522     temph = (u16)(templ | (u16)(temph << (u8)8));
1577  01ab 1e04          	ldw	x,(OFST-1,sp)
1578  01ad 4f            	clr	a
1579  01ae 02            	rlwa	x,a
1580  01af 01            	rrwa	x,a
1581  01b0 1a03          	or	a,(OFST-2,sp)
1582  01b2 02            	rlwa	x,a
1583  01b3 1f04          	ldw	(OFST-1,sp),x
1584  01b5 01            	rrwa	x,a
1586  01b6 2021          	jra	L546
1587  01b8               L346:
1588                     ; 527     temph = ADC->DRH;
1590  01b8 c65404        	ld	a,21508
1591  01bb 5f            	clrw	x
1592  01bc 97            	ld	xl,a
1593  01bd 1f04          	ldw	(OFST-1,sp),x
1594                     ; 529     templ = ADC->DRL;
1596  01bf c65405        	ld	a,21509
1597  01c2 6b03          	ld	(OFST-2,sp),a
1598                     ; 531     temph = (u16)((u16)(templ << (u8)6) | (u16)(temph << (u8)8));
1600  01c4 1e04          	ldw	x,(OFST-1,sp)
1601  01c6 4f            	clr	a
1602  01c7 02            	rlwa	x,a
1603  01c8 1f01          	ldw	(OFST-4,sp),x
1604  01ca 7b03          	ld	a,(OFST-2,sp)
1605  01cc 97            	ld	xl,a
1606  01cd a640          	ld	a,#64
1607  01cf 42            	mul	x,a
1608  01d0 01            	rrwa	x,a
1609  01d1 1a02          	or	a,(OFST-3,sp)
1610  01d3 01            	rrwa	x,a
1611  01d4 1a01          	or	a,(OFST-4,sp)
1612  01d6 01            	rrwa	x,a
1613  01d7 1f04          	ldw	(OFST-1,sp),x
1614  01d9               L546:
1615                     ; 534   return ((u16)temph);
1617  01d9 1e04          	ldw	x,(OFST-1,sp)
1620  01db 5b05          	addw	sp,#5
1621  01dd 81            	ret
1667                     ; 555 void ADC_AWDGChannelConfig(ADC_Channel_TypeDef Channel, FunctionalState NewState)
1667                     ; 556 {
1668                     	switch	.text
1669  01de               _ADC_AWDGChannelConfig:
1671  01de 89            	pushw	x
1672       00000000      OFST:	set	0
1675                     ; 558   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
1677                     ; 559   assert_param(IS_ADC_CHANNEL_OK(Channel));
1679                     ; 561   if (Channel < (u8)8)
1681  01df 9e            	ld	a,xh
1682  01e0 a108          	cp	a,#8
1683  01e2 242e          	jruge	L176
1684                     ; 563     if (NewState != DISABLE)
1686  01e4 9f            	ld	a,xl
1687  01e5 4d            	tnz	a
1688  01e6 2714          	jreq	L376
1689                     ; 565       ADC->AWENL |= (u8)((u8)1 << Channel);
1691  01e8 9e            	ld	a,xh
1692  01e9 5f            	clrw	x
1693  01ea 97            	ld	xl,a
1694  01eb a601          	ld	a,#1
1695  01ed 5d            	tnzw	x
1696  01ee 2704          	jreq	L65
1697  01f0               L06:
1698  01f0 48            	sll	a
1699  01f1 5a            	decw	x
1700  01f2 26fc          	jrne	L06
1701  01f4               L65:
1702  01f4 ca540f        	or	a,21519
1703  01f7 c7540f        	ld	21519,a
1705  01fa 2047          	jra	L776
1706  01fc               L376:
1707                     ; 569       ADC->AWENL &= (u8)(~((u8)1 << Channel));
1709  01fc 7b01          	ld	a,(OFST+1,sp)
1710  01fe 5f            	clrw	x
1711  01ff 97            	ld	xl,a
1712  0200 a601          	ld	a,#1
1713  0202 5d            	tnzw	x
1714  0203 2704          	jreq	L26
1715  0205               L46:
1716  0205 48            	sll	a
1717  0206 5a            	decw	x
1718  0207 26fc          	jrne	L46
1719  0209               L26:
1720  0209 43            	cpl	a
1721  020a c4540f        	and	a,21519
1722  020d c7540f        	ld	21519,a
1723  0210 2031          	jra	L776
1724  0212               L176:
1725                     ; 574     if (NewState != DISABLE)
1727  0212 0d02          	tnz	(OFST+2,sp)
1728  0214 2717          	jreq	L107
1729                     ; 576       ADC->AWENH |= (u8)((u8)1 << (Channel - (u8)8));
1731  0216 7b01          	ld	a,(OFST+1,sp)
1732  0218 a008          	sub	a,#8
1733  021a 5f            	clrw	x
1734  021b 97            	ld	xl,a
1735  021c a601          	ld	a,#1
1736  021e 5d            	tnzw	x
1737  021f 2704          	jreq	L66
1738  0221               L07:
1739  0221 48            	sll	a
1740  0222 5a            	decw	x
1741  0223 26fc          	jrne	L07
1742  0225               L66:
1743  0225 ca540e        	or	a,21518
1744  0228 c7540e        	ld	21518,a
1746  022b 2016          	jra	L776
1747  022d               L107:
1748                     ; 580       ADC->AWENH &= (u8)(~((u8)1 << (Channel - (u8)8)));
1750  022d 7b01          	ld	a,(OFST+1,sp)
1751  022f a008          	sub	a,#8
1752  0231 5f            	clrw	x
1753  0232 97            	ld	xl,a
1754  0233 a601          	ld	a,#1
1755  0235 5d            	tnzw	x
1756  0236 2704          	jreq	L27
1757  0238               L47:
1758  0238 48            	sll	a
1759  0239 5a            	decw	x
1760  023a 26fc          	jrne	L47
1761  023c               L27:
1762  023c 43            	cpl	a
1763  023d c4540e        	and	a,21518
1764  0240 c7540e        	ld	21518,a
1765  0243               L776:
1766                     ; 583 }
1769  0243 85            	popw	x
1770  0244 81            	ret
1805                     ; 600 void ADC_SetHighThreshold(u16 Threshold)
1805                     ; 601 {
1806                     	switch	.text
1807  0245               _ADC_SetHighThreshold:
1809  0245 89            	pushw	x
1810       00000000      OFST:	set	0
1813                     ; 602   ADC->VRHM = (u8)(Threshold >> (u8)2);
1815  0246 54            	srlw	x
1816  0247 54            	srlw	x
1817  0248 9f            	ld	a,xl
1818  0249 c75408        	ld	21512,a
1819                     ; 603   ADC->VRHL = (u8)Threshold;
1821  024c 7b02          	ld	a,(OFST+2,sp)
1822  024e c75409        	ld	21513,a
1823                     ; 604 }
1826  0251 85            	popw	x
1827  0252 81            	ret
1862                     ; 621 void ADC_SetLowThreshold(u16 Threshold)
1862                     ; 622 {
1863                     	switch	.text
1864  0253               _ADC_SetLowThreshold:
1866  0253 89            	pushw	x
1867       00000000      OFST:	set	0
1870                     ; 623   ADC->VRLM = (u8)(Threshold >> (u8)2);
1872  0254 54            	srlw	x
1873  0255 54            	srlw	x
1874  0256 9f            	ld	a,xl
1875  0257 c7540a        	ld	21514,a
1876                     ; 624   ADC->VRLL = (u8)Threshold;
1878  025a 7b02          	ld	a,(OFST+2,sp)
1879  025c c7540b        	ld	21515,a
1880                     ; 625 }
1883  025f 85            	popw	x
1884  0260 81            	ret
1936                     ; 642 u16 ADC_GetBufferValue(u8 Buffer)
1936                     ; 643 {
1937                     	switch	.text
1938  0261               _ADC_GetBufferValue:
1940  0261 88            	push	a
1941  0262 5205          	subw	sp,#5
1942       00000005      OFST:	set	5
1945                     ; 645   u16 temph = 0;
1947  0264 1e04          	ldw	x,(OFST-1,sp)
1948                     ; 646   u8 templ = 0;
1950  0266 7b03          	ld	a,(OFST-2,sp)
1951  0268 97            	ld	xl,a
1952                     ; 649   assert_param(IS_ADC_BUFFER_OK(Buffer));
1954                     ; 651   if (ADC->CR2 & ADC_CR2_ALIGN) /* Right alignment */
1956  0269 c65402        	ld	a,21506
1957  026c a508          	bcp	a,#8
1958  026e 2723          	jreq	L767
1959                     ; 654     templ = *(u8*)(ADC_BaseAddress + (Buffer << 1) + 1);
1961  0270 7b06          	ld	a,(OFST+1,sp)
1962  0272 5f            	clrw	x
1963  0273 97            	ld	xl,a
1964  0274 58            	sllw	x
1965  0275 d653e1        	ld	a,(21473,x)
1966  0278 6b03          	ld	(OFST-2,sp),a
1967                     ; 656     temph = *(u8*)(ADC_BaseAddress + (Buffer << 1));
1969  027a 7b06          	ld	a,(OFST+1,sp)
1970  027c 5f            	clrw	x
1971  027d 97            	ld	xl,a
1972  027e 58            	sllw	x
1973  027f d653e0        	ld	a,(21472,x)
1974  0282 5f            	clrw	x
1975  0283 97            	ld	xl,a
1976  0284 1f04          	ldw	(OFST-1,sp),x
1977                     ; 658     temph = (u16)(templ | (u16)(temph << (u8)8));
1979  0286 1e04          	ldw	x,(OFST-1,sp)
1980  0288 4f            	clr	a
1981  0289 02            	rlwa	x,a
1982  028a 01            	rrwa	x,a
1983  028b 1a03          	or	a,(OFST-2,sp)
1984  028d 02            	rlwa	x,a
1985  028e 1f04          	ldw	(OFST-1,sp),x
1986  0290 01            	rrwa	x,a
1988  0291 202b          	jra	L177
1989  0293               L767:
1990                     ; 663     temph = *(u8*)(ADC_BaseAddress + (Buffer << 1));
1992  0293 7b06          	ld	a,(OFST+1,sp)
1993  0295 5f            	clrw	x
1994  0296 97            	ld	xl,a
1995  0297 58            	sllw	x
1996  0298 d653e0        	ld	a,(21472,x)
1997  029b 5f            	clrw	x
1998  029c 97            	ld	xl,a
1999  029d 1f04          	ldw	(OFST-1,sp),x
2000                     ; 665     templ = *(u8*)(ADC_BaseAddress + (Buffer << 1) + 1);
2002  029f 7b06          	ld	a,(OFST+1,sp)
2003  02a1 5f            	clrw	x
2004  02a2 97            	ld	xl,a
2005  02a3 58            	sllw	x
2006  02a4 d653e1        	ld	a,(21473,x)
2007  02a7 6b03          	ld	(OFST-2,sp),a
2008                     ; 667     temph = (u16)((u16)(templ << (u8)6) | (u16)(temph << (u8)8));
2010  02a9 1e04          	ldw	x,(OFST-1,sp)
2011  02ab 4f            	clr	a
2012  02ac 02            	rlwa	x,a
2013  02ad 1f01          	ldw	(OFST-4,sp),x
2014  02af 7b03          	ld	a,(OFST-2,sp)
2015  02b1 97            	ld	xl,a
2016  02b2 a640          	ld	a,#64
2017  02b4 42            	mul	x,a
2018  02b5 01            	rrwa	x,a
2019  02b6 1a02          	or	a,(OFST-3,sp)
2020  02b8 01            	rrwa	x,a
2021  02b9 1a01          	or	a,(OFST-4,sp)
2022  02bb 01            	rrwa	x,a
2023  02bc 1f04          	ldw	(OFST-1,sp),x
2024  02be               L177:
2025                     ; 670   return ((u16)temph);
2027  02be 1e04          	ldw	x,(OFST-1,sp)
2030  02c0 5b06          	addw	sp,#6
2031  02c2 81            	ret
2097                     ; 690 FlagStatus ADC_GetAWDGChannelStatus(ADC_Channel_TypeDef Channel)
2097                     ; 691 {
2098                     	switch	.text
2099  02c3               _ADC_GetAWDGChannelStatus:
2101  02c3 88            	push	a
2102  02c4 88            	push	a
2103       00000001      OFST:	set	1
2106                     ; 692   u8 status = 0;
2108  02c5 0f01          	clr	(OFST+0,sp)
2109                     ; 695   assert_param(IS_ADC_CHANNEL_OK(Channel));
2111                     ; 697   if (Channel < (u8)8)
2113  02c7 a108          	cp	a,#8
2114  02c9 2412          	jruge	L5201
2115                     ; 699     status = (u8)(ADC->AWL & ((u8)1 << Channel));
2117  02cb 5f            	clrw	x
2118  02cc 97            	ld	xl,a
2119  02cd a601          	ld	a,#1
2120  02cf 5d            	tnzw	x
2121  02d0 2704          	jreq	L601
2122  02d2               L011:
2123  02d2 48            	sll	a
2124  02d3 5a            	decw	x
2125  02d4 26fc          	jrne	L011
2126  02d6               L601:
2127  02d6 c4540d        	and	a,21517
2128  02d9 6b01          	ld	(OFST+0,sp),a
2130  02db 2014          	jra	L7201
2131  02dd               L5201:
2132                     ; 703     status = (u8)(ADC->AWH & ((u8)1 << (Channel - (u8)8)));
2134  02dd 7b02          	ld	a,(OFST+1,sp)
2135  02df a008          	sub	a,#8
2136  02e1 5f            	clrw	x
2137  02e2 97            	ld	xl,a
2138  02e3 a601          	ld	a,#1
2139  02e5 5d            	tnzw	x
2140  02e6 2704          	jreq	L211
2141  02e8               L411:
2142  02e8 48            	sll	a
2143  02e9 5a            	decw	x
2144  02ea 26fc          	jrne	L411
2145  02ec               L211:
2146  02ec c4540c        	and	a,21516
2147  02ef 6b01          	ld	(OFST+0,sp),a
2148  02f1               L7201:
2149                     ; 706   return ((FlagStatus)status);
2151  02f1 7b01          	ld	a,(OFST+0,sp)
2154  02f3 85            	popw	x
2155  02f4 81            	ret
2306                     ; 725 FlagStatus ADC_GetFlagStatus(ADC_Flag_TypeDef Flag)
2306                     ; 726 {
2307                     	switch	.text
2308  02f5               _ADC_GetFlagStatus:
2310  02f5 88            	push	a
2311  02f6 88            	push	a
2312       00000001      OFST:	set	1
2315                     ; 727   u8 flagstatus = 0;
2317  02f7 7b01          	ld	a,(OFST+0,sp)
2318  02f9 97            	ld	xl,a
2319                     ; 728   u8 temp = 0;
2321  02fa 7b01          	ld	a,(OFST+0,sp)
2322  02fc 97            	ld	xl,a
2323                     ; 731   assert_param(IS_ADC_FLAG_OK(Flag));
2325                     ; 733   if ((Flag & 0x0F) == 0x01)
2327  02fd 7b02          	ld	a,(OFST+1,sp)
2328  02ff a40f          	and	a,#15
2329  0301 a101          	cp	a,#1
2330  0303 2609          	jrne	L5111
2331                     ; 736     flagstatus = (u8)(ADC->CR3 & ADC_CR3_OVR);
2333  0305 c65403        	ld	a,21507
2334  0308 a440          	and	a,#64
2335  030a 6b01          	ld	(OFST+0,sp),a
2337  030c 2045          	jra	L7111
2338  030e               L5111:
2339                     ; 738   else if ((Flag & 0xF0) == 0x10)
2341  030e 7b02          	ld	a,(OFST+1,sp)
2342  0310 a4f0          	and	a,#240
2343  0312 a110          	cp	a,#16
2344  0314 2636          	jrne	L1211
2345                     ; 741     temp = (u8)(Flag & 0x0F);
2347  0316 7b02          	ld	a,(OFST+1,sp)
2348  0318 a40f          	and	a,#15
2349  031a 6b01          	ld	(OFST+0,sp),a
2350                     ; 742     if (temp < 8)
2352  031c 7b01          	ld	a,(OFST+0,sp)
2353  031e a108          	cp	a,#8
2354  0320 2414          	jruge	L3211
2355                     ; 744       flagstatus = (u8)(ADC->AWL & (1 << temp));
2357  0322 7b01          	ld	a,(OFST+0,sp)
2358  0324 5f            	clrw	x
2359  0325 97            	ld	xl,a
2360  0326 a601          	ld	a,#1
2361  0328 5d            	tnzw	x
2362  0329 2704          	jreq	L021
2363  032b               L221:
2364  032b 48            	sll	a
2365  032c 5a            	decw	x
2366  032d 26fc          	jrne	L221
2367  032f               L021:
2368  032f c4540d        	and	a,21517
2369  0332 6b01          	ld	(OFST+0,sp),a
2371  0334 201d          	jra	L7111
2372  0336               L3211:
2373                     ; 748       flagstatus = (u8)(ADC->AWH & (1 << (temp - 8)));
2375  0336 7b01          	ld	a,(OFST+0,sp)
2376  0338 a008          	sub	a,#8
2377  033a 5f            	clrw	x
2378  033b 97            	ld	xl,a
2379  033c a601          	ld	a,#1
2380  033e 5d            	tnzw	x
2381  033f 2704          	jreq	L421
2382  0341               L621:
2383  0341 48            	sll	a
2384  0342 5a            	decw	x
2385  0343 26fc          	jrne	L621
2386  0345               L421:
2387  0345 c4540c        	and	a,21516
2388  0348 6b01          	ld	(OFST+0,sp),a
2389  034a 2007          	jra	L7111
2390  034c               L1211:
2391                     ; 753     flagstatus = (u8)(ADC->CSR & Flag);
2393  034c c65400        	ld	a,21504
2394  034f 1402          	and	a,(OFST+1,sp)
2395  0351 6b01          	ld	(OFST+0,sp),a
2396  0353               L7111:
2397                     ; 755   return ((FlagStatus)flagstatus);
2399  0353 7b01          	ld	a,(OFST+0,sp)
2402  0355 85            	popw	x
2403  0356 81            	ret
2447                     ; 774 void ADC_ClearFlag(ADC_Flag_TypeDef Flag)
2447                     ; 775 {
2448                     	switch	.text
2449  0357               _ADC_ClearFlag:
2451  0357 88            	push	a
2452  0358 88            	push	a
2453       00000001      OFST:	set	1
2456                     ; 776   u8 temp = 0;
2458  0359 0f01          	clr	(OFST+0,sp)
2459                     ; 779   assert_param(IS_ADC_FLAG_OK(Flag));
2461                     ; 781   if ((Flag & 0x0F) == 0x01)
2463  035b a40f          	and	a,#15
2464  035d a101          	cp	a,#1
2465  035f 2606          	jrne	L3511
2466                     ; 784     ADC->CR3 &= (u8)(~ADC_CR3_OVR);
2468  0361 721d5403      	bres	21507,#6
2470  0365 204b          	jra	L5511
2471  0367               L3511:
2472                     ; 786   else if ((Flag & 0xF0) == 0x10)
2474  0367 7b02          	ld	a,(OFST+1,sp)
2475  0369 a4f0          	and	a,#240
2476  036b a110          	cp	a,#16
2477  036d 263a          	jrne	L7511
2478                     ; 789     temp = (u8)(Flag & 0x0F);
2480  036f 7b02          	ld	a,(OFST+1,sp)
2481  0371 a40f          	and	a,#15
2482  0373 6b01          	ld	(OFST+0,sp),a
2483                     ; 790     if (temp < 8)
2485  0375 7b01          	ld	a,(OFST+0,sp)
2486  0377 a108          	cp	a,#8
2487  0379 2416          	jruge	L1611
2488                     ; 792       ADC->AWL &= (u8)(~((u8)1 << temp));
2490  037b 7b01          	ld	a,(OFST+0,sp)
2491  037d 5f            	clrw	x
2492  037e 97            	ld	xl,a
2493  037f a601          	ld	a,#1
2494  0381 5d            	tnzw	x
2495  0382 2704          	jreq	L231
2496  0384               L431:
2497  0384 48            	sll	a
2498  0385 5a            	decw	x
2499  0386 26fc          	jrne	L431
2500  0388               L231:
2501  0388 43            	cpl	a
2502  0389 c4540d        	and	a,21517
2503  038c c7540d        	ld	21517,a
2505  038f 2021          	jra	L5511
2506  0391               L1611:
2507                     ; 796       ADC->AWH &= (u8)(~((u8)1 << (temp - 8)));
2509  0391 7b01          	ld	a,(OFST+0,sp)
2510  0393 a008          	sub	a,#8
2511  0395 5f            	clrw	x
2512  0396 97            	ld	xl,a
2513  0397 a601          	ld	a,#1
2514  0399 5d            	tnzw	x
2515  039a 2704          	jreq	L631
2516  039c               L041:
2517  039c 48            	sll	a
2518  039d 5a            	decw	x
2519  039e 26fc          	jrne	L041
2520  03a0               L631:
2521  03a0 43            	cpl	a
2522  03a1 c4540c        	and	a,21516
2523  03a4 c7540c        	ld	21516,a
2524  03a7 2009          	jra	L5511
2525  03a9               L7511:
2526                     ; 801     ADC->CSR &= (u8) (~Flag);
2528  03a9 7b02          	ld	a,(OFST+1,sp)
2529  03ab 43            	cpl	a
2530  03ac c45400        	and	a,21504
2531  03af c75400        	ld	21504,a
2532  03b2               L5511:
2533                     ; 803 }
2536  03b2 85            	popw	x
2537  03b3 81            	ret
2592                     ; 833 ITStatus ADC_GetITStatus(ADC_IT_TypeDef ITPendingBit)
2592                     ; 834 {
2593                     	switch	.text
2594  03b4               _ADC_GetITStatus:
2596  03b4 88            	push	a
2597  03b5 88            	push	a
2598       00000001      OFST:	set	1
2601                     ; 835   ITStatus itstatus = RESET;
2603  03b6 7b01          	ld	a,(OFST+0,sp)
2604  03b8 97            	ld	xl,a
2605                     ; 836   u8 temp = 0;
2607  03b9 7b01          	ld	a,(OFST+0,sp)
2608  03bb 97            	ld	xl,a
2609                     ; 839   assert_param(IS_ADC_ITPENDINGBIT_OK(ITPendingBit));
2611                     ; 841   if ((ITPendingBit & 0xF0) == 0x10)
2613  03bc 7b02          	ld	a,(OFST+1,sp)
2614  03be a4f0          	and	a,#240
2615  03c0 a110          	cp	a,#16
2616  03c2 2636          	jrne	L5121
2617                     ; 844     temp = (u8)(ITPendingBit & 0x0F);
2619  03c4 7b02          	ld	a,(OFST+1,sp)
2620  03c6 a40f          	and	a,#15
2621  03c8 6b01          	ld	(OFST+0,sp),a
2622                     ; 845     if (temp < 8)
2624  03ca 7b01          	ld	a,(OFST+0,sp)
2625  03cc a108          	cp	a,#8
2626  03ce 2414          	jruge	L7121
2627                     ; 847       itstatus = (u8)(ADC->AWL & (u8)((u8)1 << temp));
2629  03d0 7b01          	ld	a,(OFST+0,sp)
2630  03d2 5f            	clrw	x
2631  03d3 97            	ld	xl,a
2632  03d4 a601          	ld	a,#1
2633  03d6 5d            	tnzw	x
2634  03d7 2704          	jreq	L441
2635  03d9               L641:
2636  03d9 48            	sll	a
2637  03da 5a            	decw	x
2638  03db 26fc          	jrne	L641
2639  03dd               L441:
2640  03dd c4540d        	and	a,21517
2641  03e0 6b01          	ld	(OFST+0,sp),a
2643  03e2 201d          	jra	L3221
2644  03e4               L7121:
2645                     ; 851       itstatus = (u8)(ADC->AWH & (u8)((u8)1 << (temp - 8)));
2647  03e4 7b01          	ld	a,(OFST+0,sp)
2648  03e6 a008          	sub	a,#8
2649  03e8 5f            	clrw	x
2650  03e9 97            	ld	xl,a
2651  03ea a601          	ld	a,#1
2652  03ec 5d            	tnzw	x
2653  03ed 2704          	jreq	L051
2654  03ef               L251:
2655  03ef 48            	sll	a
2656  03f0 5a            	decw	x
2657  03f1 26fc          	jrne	L251
2658  03f3               L051:
2659  03f3 c4540c        	and	a,21516
2660  03f6 6b01          	ld	(OFST+0,sp),a
2661  03f8 2007          	jra	L3221
2662  03fa               L5121:
2663                     ; 856     itstatus = (u8)(ADC->CSR & ITPendingBit);
2665  03fa c65400        	ld	a,21504
2666  03fd 1402          	and	a,(OFST+1,sp)
2667  03ff 6b01          	ld	(OFST+0,sp),a
2668  0401               L3221:
2669                     ; 858   return ((ITStatus)itstatus);
2671  0401 7b01          	ld	a,(OFST+0,sp)
2674  0403 85            	popw	x
2675  0404 81            	ret
2720                     ; 889 void ADC_ClearITPendingBit(ADC_IT_TypeDef ITPendingBit)
2720                     ; 890 {
2721                     	switch	.text
2722  0405               _ADC_ClearITPendingBit:
2724  0405 88            	push	a
2725  0406 88            	push	a
2726       00000001      OFST:	set	1
2729                     ; 891   u8 temp = 0;
2731  0407 0f01          	clr	(OFST+0,sp)
2732                     ; 894   assert_param(IS_ADC_ITPENDINGBIT_OK(ITPendingBit));
2734                     ; 896   if ((ITPendingBit& 0xF0) == 0x10)
2736  0409 a4f0          	and	a,#240
2737  040b a110          	cp	a,#16
2738  040d 263a          	jrne	L7421
2739                     ; 899     temp = (u8)(ITPendingBit & 0x0F);
2741  040f 7b02          	ld	a,(OFST+1,sp)
2742  0411 a40f          	and	a,#15
2743  0413 6b01          	ld	(OFST+0,sp),a
2744                     ; 900     if (temp < 8)
2746  0415 7b01          	ld	a,(OFST+0,sp)
2747  0417 a108          	cp	a,#8
2748  0419 2416          	jruge	L1521
2749                     ; 902       ADC->AWL &= (u8)(~((u8)1 << temp));
2751  041b 7b01          	ld	a,(OFST+0,sp)
2752  041d 5f            	clrw	x
2753  041e 97            	ld	xl,a
2754  041f a601          	ld	a,#1
2755  0421 5d            	tnzw	x
2756  0422 2704          	jreq	L651
2757  0424               L061:
2758  0424 48            	sll	a
2759  0425 5a            	decw	x
2760  0426 26fc          	jrne	L061
2761  0428               L651:
2762  0428 43            	cpl	a
2763  0429 c4540d        	and	a,21517
2764  042c c7540d        	ld	21517,a
2766  042f 2021          	jra	L5521
2767  0431               L1521:
2768                     ; 906       ADC->AWH &= (u8)(~((u8)1 << (temp - 8)));
2770  0431 7b01          	ld	a,(OFST+0,sp)
2771  0433 a008          	sub	a,#8
2772  0435 5f            	clrw	x
2773  0436 97            	ld	xl,a
2774  0437 a601          	ld	a,#1
2775  0439 5d            	tnzw	x
2776  043a 2704          	jreq	L261
2777  043c               L461:
2778  043c 48            	sll	a
2779  043d 5a            	decw	x
2780  043e 26fc          	jrne	L461
2781  0440               L261:
2782  0440 43            	cpl	a
2783  0441 c4540c        	and	a,21516
2784  0444 c7540c        	ld	21516,a
2785  0447 2009          	jra	L5521
2786  0449               L7421:
2787                     ; 911     ADC->CSR &= (u8) (~ITPendingBit);
2789  0449 7b02          	ld	a,(OFST+1,sp)
2790  044b 43            	cpl	a
2791  044c c45400        	and	a,21504
2792  044f c75400        	ld	21504,a
2793  0452               L5521:
2794                     ; 913 }
2797  0452 85            	popw	x
2798  0453 81            	ret
2811                     	xdef	_ADC_ClearITPendingBit
2812                     	xdef	_ADC_GetITStatus
2813                     	xdef	_ADC_ClearFlag
2814                     	xdef	_ADC_GetFlagStatus
2815                     	xdef	_ADC_GetAWDGChannelStatus
2816                     	xdef	_ADC_GetBufferValue
2817                     	xdef	_ADC_SetLowThreshold
2818                     	xdef	_ADC_SetHighThreshold
2819                     	xdef	_ADC_GetConversionValue
2820                     	xdef	_ADC_StartConversion
2821                     	xdef	_ADC_AWDGChannelConfig
2822                     	xdef	_ADC_ExternalTriggerConfig
2823                     	xdef	_ADC_ConversionConfig
2824                     	xdef	_ADC_SchmittTriggerConfig
2825                     	xdef	_ADC_PrescalerConfig
2826                     	xdef	_ADC_ITConfig
2827                     	xdef	_ADC_DataBufferCmd
2828                     	xdef	_ADC_ScanModeCmd
2829                     	xdef	_ADC_Cmd
2830                     	xdef	_ADC_Init
2831                     	xdef	_ADC_DeInit
2850                     	end
