   1                     ; C Compiler for STM8 (COSMIC Software)
   2                     ; Generator V4.2.4 - 19 Dec 2007
   4                     .const:	section	.text
   5  0000               _HSIDivFactor:
   6  0000 01            	dc.b	1
   7  0001 02            	dc.b	2
   8  0002 04            	dc.b	4
   9  0003 08            	dc.b	8
  10  0004               _CLKPrescTable:
  11  0004 01            	dc.b	1
  12  0005 02            	dc.b	2
  13  0006 04            	dc.b	4
  14  0007 08            	dc.b	8
  15  0008 0a            	dc.b	10
  16  0009 10            	dc.b	16
  17  000a 14            	dc.b	20
  18  000b 28            	dc.b	40
  47                     ; 83 void CLK_DeInit(void)
  47                     ; 84 {
  49                     	switch	.text
  50  0000               _CLK_DeInit:
  54                     ; 86   CLK->ICKR = CLK_ICKR_RESET_VALUE;
  56  0000 350150c0      	mov	20672,#1
  57                     ; 87   CLK->ECKR = CLK_ECKR_RESET_VALUE;
  59  0004 725f50c1      	clr	20673
  60                     ; 88   CLK->SWR  = CLK_SWR_RESET_VALUE;
  62  0008 35e150c4      	mov	20676,#225
  63                     ; 89   CLK->SWCR = CLK_SWCR_RESET_VALUE;
  65  000c 725f50c5      	clr	20677
  66                     ; 90   CLK->CKDIVR = CLK_CKDIVR_RESET_VALUE;
  68  0010 351850c6      	mov	20678,#24
  69                     ; 91   CLK->PCKENR1 = CLK_PCKENR1_RESET_VALUE;
  71  0014 35ff50c7      	mov	20679,#255
  72                     ; 92   CLK->PCKENR2 = CLK_PCKENR2_RESET_VALUE;
  74  0018 35ff50ca      	mov	20682,#255
  75                     ; 93   CLK->CSSR = CLK_CSSR_RESET_VALUE;
  77  001c 725f50c8      	clr	20680
  78                     ; 95   CLK->CCOR = CLK_CCOR_RESET_VALUE;
  80  0020 725f50c9      	clr	20681
  82  0024               L52:
  83                     ; 96   while (CLK->CCOR & CLK_CCOR_CCOEN)
  85  0024 c650c9        	ld	a,20681
  86  0027 a501          	bcp	a,#1
  87  0029 26f9          	jrne	L52
  88                     ; 98   CLK->CCOR = CLK_CCOR_RESET_VALUE;
  90  002b 725f50c9      	clr	20681
  91                     ; 100   CLK->CANCCR = CLK_CANCCR_RESET_VALUE;
  93  002f 725f50cb      	clr	20683
  94                     ; 101   CLK->HSITRIMR = CLK_HSITRIMR_RESET_VALUE;
  96  0033 725f50cc      	clr	20684
  97                     ; 102   CLK->SWIMCCR = CLK_SWIMCCR_RESET_VALUE;
  99  0037 725f50cd      	clr	20685
 100                     ; 104 }
 103  003b 81            	ret
 159                     ; 123 void CLK_FastHaltWakeUpCmd(FunctionalState NewState)
 159                     ; 124 {
 160                     	switch	.text
 161  003c               _CLK_FastHaltWakeUpCmd:
 165                     ; 127   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 167                     ; 129   if (NewState != DISABLE)
 169  003c 4d            	tnz	a
 170  003d 2706          	jreq	L75
 171                     ; 132     CLK->ICKR |= CLK_ICKR_FHWU;
 173  003f 721450c0      	bset	20672,#2
 175  0043 2004          	jra	L16
 176  0045               L75:
 177                     ; 137     CLK->ICKR &= (u8)(~CLK_ICKR_FHWU);
 179  0045 721550c0      	bres	20672,#2
 180  0049               L16:
 181                     ; 140 }
 184  0049 81            	ret
 219                     ; 154 void CLK_HSECmd(FunctionalState CLK_NewState)
 219                     ; 155 {
 220                     	switch	.text
 221  004a               _CLK_HSECmd:
 225                     ; 158   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 227                     ; 160   if (CLK_NewState != DISABLE)
 229  004a 4d            	tnz	a
 230  004b 2706          	jreq	L101
 231                     ; 163     CLK->ECKR |= CLK_ECKR_HSEEN;
 233  004d 721050c1      	bset	20673,#0
 235  0051 2004          	jra	L301
 236  0053               L101:
 237                     ; 168     CLK->ECKR &= (u8)(~CLK_ECKR_HSEEN);
 239  0053 721150c1      	bres	20673,#0
 240  0057               L301:
 241                     ; 171 }
 244  0057 81            	ret
 279                     ; 185 void CLK_HSICmd(FunctionalState CLK_NewState)
 279                     ; 186 {
 280                     	switch	.text
 281  0058               _CLK_HSICmd:
 285                     ; 189   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 287                     ; 191   if (CLK_NewState != DISABLE)
 289  0058 4d            	tnz	a
 290  0059 2706          	jreq	L321
 291                     ; 194     CLK->ICKR |= CLK_ICKR_HSIEN;
 293  005b 721050c0      	bset	20672,#0
 295  005f 2004          	jra	L521
 296  0061               L321:
 297                     ; 199     CLK->ICKR &= (u8)(~CLK_ICKR_HSIEN);
 299  0061 721150c0      	bres	20672,#0
 300  0065               L521:
 301                     ; 202 }
 304  0065 81            	ret
 339                     ; 216 void CLK_LSICmd(FunctionalState CLK_NewState)
 339                     ; 217 {
 340                     	switch	.text
 341  0066               _CLK_LSICmd:
 345                     ; 220   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 347                     ; 222   if (CLK_NewState != DISABLE)
 349  0066 4d            	tnz	a
 350  0067 2706          	jreq	L541
 351                     ; 225     CLK->ICKR |= CLK_ICKR_LSIEN;
 353  0069 721650c0      	bset	20672,#3
 355  006d 2004          	jra	L741
 356  006f               L541:
 357                     ; 230     CLK->ICKR &= (u8)(~CLK_ICKR_LSIEN);
 359  006f 721750c0      	bres	20672,#3
 360  0073               L741:
 361                     ; 233 }
 364  0073 81            	ret
 399                     ; 248 void CLK_CCOCmd(FunctionalState CLK_NewState)
 399                     ; 249 {
 400                     	switch	.text
 401  0074               _CLK_CCOCmd:
 405                     ; 252   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 407                     ; 254   if (CLK_NewState != DISABLE)
 409  0074 4d            	tnz	a
 410  0075 2706          	jreq	L761
 411                     ; 257     CLK->CCOR |= CLK_CCOR_CCOEN;
 413  0077 721050c9      	bset	20681,#0
 415  007b 2004          	jra	L171
 416  007d               L761:
 417                     ; 262     CLK->CCOR &= (u8)(~CLK_CCOR_CCOEN);
 419  007d 721150c9      	bres	20681,#0
 420  0081               L171:
 421                     ; 265 }
 424  0081 81            	ret
 459                     ; 281 void CLK_ClockSwitchCmd(FunctionalState CLK_NewState)
 459                     ; 282 {
 460                     	switch	.text
 461  0082               _CLK_ClockSwitchCmd:
 465                     ; 285   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 467                     ; 287   if (CLK_NewState != DISABLE )
 469  0082 4d            	tnz	a
 470  0083 2706          	jreq	L112
 471                     ; 290     CLK->SWCR |= CLK_SWCR_SWEN;
 473  0085 721250c5      	bset	20677,#1
 475  0089 2004          	jra	L312
 476  008b               L112:
 477                     ; 295     CLK->SWCR &= (u8)(~CLK_SWCR_SWEN);
 479  008b 721350c5      	bres	20677,#1
 480  008f               L312:
 481                     ; 298 }
 484  008f 81            	ret
 520                     ; 315 void CLK_SlowActiveHaltWakeUpCmd(FunctionalState NewState)
 520                     ; 316 {
 521                     	switch	.text
 522  0090               _CLK_SlowActiveHaltWakeUpCmd:
 526                     ; 319   assert_param(IS_FUNCTIONALSTATE_OK(NewState));
 528                     ; 321   if (NewState != DISABLE)
 530  0090 4d            	tnz	a
 531  0091 2706          	jreq	L332
 532                     ; 324     CLK->ICKR |= CLK_ICKR_SWUAH;
 534  0093 721a50c0      	bset	20672,#5
 536  0097 2004          	jra	L532
 537  0099               L332:
 538                     ; 329     CLK->ICKR &= (u8)(~CLK_ICKR_SWUAH);
 540  0099 721b50c0      	bres	20672,#5
 541  009d               L532:
 542                     ; 332 }
 545  009d 81            	ret
 680                     ; 349 void CLK_PeripheralClockConfig(CLK_Peripheral_TypeDef CLK_Peripheral, FunctionalState CLK_NewState)
 680                     ; 350 {
 681                     	switch	.text
 682  009e               _CLK_PeripheralClockConfig:
 684  009e 89            	pushw	x
 685       00000000      OFST:	set	0
 688                     ; 353   assert_param(IS_FUNCTIONALSTATE_OK(CLK_NewState));
 690                     ; 354   assert_param(IS_CLK_PERIPHERAL_OK(CLK_Peripheral));
 692                     ; 356   if (((u8)CLK_Peripheral & (u8)0x10) == 0x00)
 694  009f 9e            	ld	a,xh
 695  00a0 a510          	bcp	a,#16
 696  00a2 2633          	jrne	L313
 697                     ; 358     if (CLK_NewState != DISABLE)
 699  00a4 0d02          	tnz	(OFST+2,sp)
 700  00a6 2717          	jreq	L513
 701                     ; 361       CLK->PCKENR1 |= (u8)((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F));
 703  00a8 7b01          	ld	a,(OFST+1,sp)
 704  00aa a40f          	and	a,#15
 705  00ac 5f            	clrw	x
 706  00ad 97            	ld	xl,a
 707  00ae a601          	ld	a,#1
 708  00b0 5d            	tnzw	x
 709  00b1 2704          	jreq	L62
 710  00b3               L03:
 711  00b3 48            	sll	a
 712  00b4 5a            	decw	x
 713  00b5 26fc          	jrne	L03
 714  00b7               L62:
 715  00b7 ca50c7        	or	a,20679
 716  00ba c750c7        	ld	20679,a
 718  00bd 2049          	jra	L123
 719  00bf               L513:
 720                     ; 366       CLK->PCKENR1 &= (u8)(~(u8)(((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F))));
 722  00bf 7b01          	ld	a,(OFST+1,sp)
 723  00c1 a40f          	and	a,#15
 724  00c3 5f            	clrw	x
 725  00c4 97            	ld	xl,a
 726  00c5 a601          	ld	a,#1
 727  00c7 5d            	tnzw	x
 728  00c8 2704          	jreq	L23
 729  00ca               L43:
 730  00ca 48            	sll	a
 731  00cb 5a            	decw	x
 732  00cc 26fc          	jrne	L43
 733  00ce               L23:
 734  00ce 43            	cpl	a
 735  00cf c450c7        	and	a,20679
 736  00d2 c750c7        	ld	20679,a
 737  00d5 2031          	jra	L123
 738  00d7               L313:
 739                     ; 371     if (CLK_NewState != DISABLE)
 741  00d7 0d02          	tnz	(OFST+2,sp)
 742  00d9 2717          	jreq	L323
 743                     ; 374       CLK->PCKENR2 |= (u8)((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F));
 745  00db 7b01          	ld	a,(OFST+1,sp)
 746  00dd a40f          	and	a,#15
 747  00df 5f            	clrw	x
 748  00e0 97            	ld	xl,a
 749  00e1 a601          	ld	a,#1
 750  00e3 5d            	tnzw	x
 751  00e4 2704          	jreq	L63
 752  00e6               L04:
 753  00e6 48            	sll	a
 754  00e7 5a            	decw	x
 755  00e8 26fc          	jrne	L04
 756  00ea               L63:
 757  00ea ca50ca        	or	a,20682
 758  00ed c750ca        	ld	20682,a
 760  00f0 2016          	jra	L123
 761  00f2               L323:
 762                     ; 379       CLK->PCKENR2 &= (u8)(~(u8)(((u8)1 << ((u8)CLK_Peripheral & (u8)0x0F))));
 764  00f2 7b01          	ld	a,(OFST+1,sp)
 765  00f4 a40f          	and	a,#15
 766  00f6 5f            	clrw	x
 767  00f7 97            	ld	xl,a
 768  00f8 a601          	ld	a,#1
 769  00fa 5d            	tnzw	x
 770  00fb 2704          	jreq	L24
 771  00fd               L44:
 772  00fd 48            	sll	a
 773  00fe 5a            	decw	x
 774  00ff 26fc          	jrne	L44
 775  0101               L24:
 776  0101 43            	cpl	a
 777  0102 c450ca        	and	a,20682
 778  0105 c750ca        	ld	20682,a
 779  0108               L123:
 780                     ; 383 }
 783  0108 85            	popw	x
 784  0109 81            	ret
 972                     ; 405 ErrorStatus CLK_ClockSwitchConfig(CLK_SwitchMode_TypeDef CLK_SwitchMode, CLK_Source_TypeDef CLK_NewClock, FunctionalState CLK_SwitchIT, CLK_CurrentClockState_TypeDef CLK_CurrentClockState)
 972                     ; 406 {
 973                     	switch	.text
 974  010a               _CLK_ClockSwitchConfig:
 976  010a 89            	pushw	x
 977  010b 5204          	subw	sp,#4
 978       00000004      OFST:	set	4
 981                     ; 409   u16 DownCounter = CLK_TIMEOUT;
 983  010d ae0491        	ldw	x,#1169
 984  0110 1f03          	ldw	(OFST-1,sp),x
 985                     ; 410   ErrorStatus Swif = ERROR;
 987  0112 7b02          	ld	a,(OFST-2,sp)
 988  0114 97            	ld	xl,a
 989                     ; 413   assert_param(IS_CLK_SOURCE_OK(CLK_NewClock));
 991                     ; 414   assert_param(IS_CLK_SWITCHMODE_OK(CLK_SwitchMode));
 993                     ; 415   assert_param(IS_FUNCTIONALSTATE_OK(CLK_SwitchIT));
 995                     ; 416   assert_param(IS_CLK_CURRENTCLOCKSTATE_OK(CLK_CurrentClockState));
 997                     ; 419   clock_master = (CLK_Source_TypeDef)CLK->CMSR;
 999  0115 c650c3        	ld	a,20675
1000  0118 6b01          	ld	(OFST-3,sp),a
1001                     ; 422   if (CLK_SwitchMode == CLK_SWITCHMODE_AUTO)
1003  011a 7b05          	ld	a,(OFST+1,sp)
1004  011c a101          	cp	a,#1
1005  011e 2639          	jrne	L734
1006                     ; 426     CLK->SWCR |= CLK_SWCR_SWEN;
1008  0120 721250c5      	bset	20677,#1
1009                     ; 429     if (CLK_SwitchIT != DISABLE)
1011  0124 0d09          	tnz	(OFST+5,sp)
1012  0126 2706          	jreq	L144
1013                     ; 431       CLK->SWCR |= CLK_SWCR_SWIEN;
1015  0128 721450c5      	bset	20677,#2
1017  012c 2004          	jra	L344
1018  012e               L144:
1019                     ; 435       CLK->SWCR &= (u8)(~CLK_SWCR_SWIEN);
1021  012e 721550c5      	bres	20677,#2
1022  0132               L344:
1023                     ; 439     CLK->SWR = (u8)CLK_NewClock;
1025  0132 7b06          	ld	a,(OFST+2,sp)
1026  0134 c750c4        	ld	20676,a
1028  0137 2007          	jra	L154
1029  0139               L544:
1030                     ; 443       DownCounter--;
1032  0139 1e03          	ldw	x,(OFST-1,sp)
1033  013b 1d0001        	subw	x,#1
1034  013e 1f03          	ldw	(OFST-1,sp),x
1035  0140               L154:
1036                     ; 441     while (((CLK->SWCR & CLK_SWCR_SWBSY) && (DownCounter != 0)))
1038  0140 c650c5        	ld	a,20677
1039  0143 a501          	bcp	a,#1
1040  0145 2704          	jreq	L554
1042  0147 1e03          	ldw	x,(OFST-1,sp)
1043  0149 26ee          	jrne	L544
1044  014b               L554:
1045                     ; 446     if (DownCounter != 0)
1047  014b 1e03          	ldw	x,(OFST-1,sp)
1048  014d 2706          	jreq	L754
1049                     ; 448       Swif = SUCCESS;
1051  014f a601          	ld	a,#1
1052  0151 6b02          	ld	(OFST-2,sp),a
1054  0153 201b          	jra	L364
1055  0155               L754:
1056                     ; 452       Swif = ERROR;
1058  0155 0f02          	clr	(OFST-2,sp)
1059  0157 2017          	jra	L364
1060  0159               L734:
1061                     ; 460     if (CLK_SwitchIT != DISABLE)
1063  0159 0d09          	tnz	(OFST+5,sp)
1064  015b 2706          	jreq	L564
1065                     ; 462       CLK->SWCR |= CLK_SWCR_SWIEN;
1067  015d 721450c5      	bset	20677,#2
1069  0161 2004          	jra	L764
1070  0163               L564:
1071                     ; 466       CLK->SWCR &= (u8)(~CLK_SWCR_SWIEN);
1073  0163 721550c5      	bres	20677,#2
1074  0167               L764:
1075                     ; 470     CLK->SWR = (u8)CLK_NewClock;
1077  0167 7b06          	ld	a,(OFST+2,sp)
1078  0169 c750c4        	ld	20676,a
1079                     ; 474     Swif = SUCCESS;
1081  016c a601          	ld	a,#1
1082  016e 6b02          	ld	(OFST-2,sp),a
1083  0170               L364:
1084                     ; 479   if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_HSI))
1086  0170 0d0a          	tnz	(OFST+6,sp)
1087  0172 260c          	jrne	L174
1089  0174 7b01          	ld	a,(OFST-3,sp)
1090  0176 a1e1          	cp	a,#225
1091  0178 2606          	jrne	L174
1092                     ; 481     CLK->ICKR &= (u8)(~CLK_ICKR_HSIEN);
1094  017a 721150c0      	bres	20672,#0
1096  017e 201e          	jra	L374
1097  0180               L174:
1098                     ; 483   else if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_LSI))
1100  0180 0d0a          	tnz	(OFST+6,sp)
1101  0182 260c          	jrne	L574
1103  0184 7b01          	ld	a,(OFST-3,sp)
1104  0186 a1d2          	cp	a,#210
1105  0188 2606          	jrne	L574
1106                     ; 485     CLK->ICKR &= (u8)(~CLK_ICKR_LSIEN);
1108  018a 721750c0      	bres	20672,#3
1110  018e 200e          	jra	L374
1111  0190               L574:
1112                     ; 487   else if ((CLK_CurrentClockState == CLK_CURRENTCLOCKSTATE_DISABLE) && ( clock_master == CLK_SOURCE_HSE))
1114  0190 0d0a          	tnz	(OFST+6,sp)
1115  0192 260a          	jrne	L374
1117  0194 7b01          	ld	a,(OFST-3,sp)
1118  0196 a1b4          	cp	a,#180
1119  0198 2604          	jrne	L374
1120                     ; 489     CLK->ECKR &= (u8)(~CLK_ECKR_HSEEN);
1122  019a 721150c1      	bres	20673,#0
1123  019e               L374:
1124                     ; 492   return(Swif);
1126  019e 7b02          	ld	a,(OFST-2,sp)
1129  01a0 5b06          	addw	sp,#6
1130  01a2 81            	ret
1268                     ; 509 void CLK_HSIPrescalerConfig(CLK_Prescaler_TypeDef HSIPrescaler)
1268                     ; 510 {
1269                     	switch	.text
1270  01a3               _CLK_HSIPrescalerConfig:
1272  01a3 88            	push	a
1273       00000000      OFST:	set	0
1276                     ; 513   assert_param(IS_CLK_HSIPRESCALER_OK(HSIPrescaler));
1278                     ; 516   CLK->CKDIVR &= (u8)(~CLK_CKDIVR_HSIDIV);
1280  01a4 c650c6        	ld	a,20678
1281  01a7 a4e7          	and	a,#231
1282  01a9 c750c6        	ld	20678,a
1283                     ; 519   CLK->CKDIVR |= (u8)HSIPrescaler;
1285  01ac c650c6        	ld	a,20678
1286  01af 1a01          	or	a,(OFST+1,sp)
1287  01b1 c750c6        	ld	20678,a
1288                     ; 521 }
1291  01b4 84            	pop	a
1292  01b5 81            	ret
1427                     ; 539 void CLK_CCOConfig(CLK_Output_TypeDef CLK_CCO)
1427                     ; 540 {
1428                     	switch	.text
1429  01b6               _CLK_CCOConfig:
1431  01b6 88            	push	a
1432       00000000      OFST:	set	0
1435                     ; 543   assert_param(IS_CLK_OUTPUT_OK(CLK_CCO));
1437                     ; 546   CLK->CCOR &= (u8)(~CLK_CCOR_CCOSEL);
1439  01b7 c650c9        	ld	a,20681
1440  01ba a4e1          	and	a,#225
1441  01bc c750c9        	ld	20681,a
1442                     ; 549   CLK->CCOR |= (u8)CLK_CCO;
1444  01bf c650c9        	ld	a,20681
1445  01c2 1a01          	or	a,(OFST+1,sp)
1446  01c4 c750c9        	ld	20681,a
1447                     ; 552   CLK->CCOR |= CLK_CCOR_CCOEN;
1449  01c7 721050c9      	bset	20681,#0
1450                     ; 554 }
1453  01cb 84            	pop	a
1454  01cc 81            	ret
1519                     ; 571 void CLK_ITConfig(CLK_IT_TypeDef CLK_IT, FunctionalState IT_NewState)
1519                     ; 572 {
1520                     	switch	.text
1521  01cd               _CLK_ITConfig:
1523  01cd 89            	pushw	x
1524       00000000      OFST:	set	0
1527                     ; 575   assert_param(IS_FUNCTIONALSTATE_OK(IT_NewState));
1529                     ; 576   assert_param(IS_CLK_IT_OK(CLK_IT));
1531                     ; 578   if (IT_NewState != DISABLE)
1533  01ce 9f            	ld	a,xl
1534  01cf 4d            	tnz	a
1535  01d0 2719          	jreq	L776
1536                     ; 580     switch (CLK_IT)
1538  01d2 9e            	ld	a,xh
1540                     ; 588       default:
1540                     ; 589         break;
1541  01d3 4a            	dec	a
1542  01d4 2705          	jreq	L136
1543  01d6 4a            	dec	a
1544  01d7 2708          	jreq	L336
1545  01d9 201e          	jra	L507
1546  01db               L136:
1547                     ; 582       case CLK_IT_SWIE: /* Enable the clock switch interrupt */
1547                     ; 583         CLK->SWCR |= CLK_SWCR_SWIEN;
1549  01db 721450c5      	bset	20677,#2
1550                     ; 584         break;
1552  01df 2018          	jra	L507
1553  01e1               L336:
1554                     ; 585       case CLK_IT_CSSDIE: /* Enable the clock security system detection interrupt */
1554                     ; 586         CLK->CSSR |= CLK_CSSR_CSSDIE;
1556  01e1 721450c8      	bset	20680,#2
1557                     ; 587         break;
1559  01e5 2012          	jra	L507
1560  01e7               L536:
1561                     ; 588       default:
1561                     ; 589         break;
1563  01e7 2010          	jra	L507
1564  01e9               L307:
1566  01e9 200e          	jra	L507
1567  01eb               L776:
1568                     ; 594     switch (CLK_IT)
1570  01eb 7b01          	ld	a,(OFST+1,sp)
1572                     ; 602       default:
1572                     ; 603         break;
1573  01ed 4a            	dec	a
1574  01ee 2705          	jreq	L736
1575  01f0 4a            	dec	a
1576  01f1 2708          	jreq	L146
1577  01f3 2004          	jra	L507
1578  01f5               L736:
1579                     ; 596       case CLK_IT_SWIE: /* Disable the clock switch interrupt */
1579                     ; 597         CLK->SWCR  &= (u8)(~CLK_SWCR_SWIEN);
1581  01f5 721550c5      	bres	20677,#2
1582                     ; 598         break;
1583  01f9               L507:
1584                     ; 607 }
1587  01f9 85            	popw	x
1588  01fa 81            	ret
1589  01fb               L146:
1590                     ; 599       case CLK_IT_CSSDIE: /* Disable the clock security system detection interrupt */
1590                     ; 600         CLK->CSSR &= (u8)(~CLK_CSSR_CSSDIE);
1592  01fb 721550c8      	bres	20680,#2
1593                     ; 601         break;
1595  01ff 20f8          	jra	L507
1596  0201               L346:
1597                     ; 602       default:
1597                     ; 603         break;
1599  0201 20f6          	jra	L507
1600  0203               L117:
1601  0203 20f4          	jra	L507
1636                     ; 623 void CLK_SYSCLKConfig(CLK_Prescaler_TypeDef ClockPrescaler)
1636                     ; 624 {
1637                     	switch	.text
1638  0205               _CLK_SYSCLKConfig:
1640  0205 88            	push	a
1641       00000000      OFST:	set	0
1644                     ; 627   assert_param(IS_CLK_PRESCALER_OK(ClockPrescaler));
1646                     ; 629   if (((u8)ClockPrescaler & (u8)0x80) == 0x00) /* Bit7 = 0 means HSI divider */
1648  0206 a580          	bcp	a,#128
1649  0208 2614          	jrne	L137
1650                     ; 631     CLK->CKDIVR &= (u8)(~CLK_CKDIVR_HSIDIV);
1652  020a c650c6        	ld	a,20678
1653  020d a4e7          	and	a,#231
1654  020f c750c6        	ld	20678,a
1655                     ; 632     CLK->CKDIVR |= (u8)((u8)ClockPrescaler & (u8)CLK_CKDIVR_HSIDIV);
1657  0212 7b01          	ld	a,(OFST+1,sp)
1658  0214 a418          	and	a,#24
1659  0216 ca50c6        	or	a,20678
1660  0219 c750c6        	ld	20678,a
1662  021c 2012          	jra	L337
1663  021e               L137:
1664                     ; 636     CLK->CKDIVR &= (u8)(~CLK_CKDIVR_CPUDIV);
1666  021e c650c6        	ld	a,20678
1667  0221 a4f8          	and	a,#248
1668  0223 c750c6        	ld	20678,a
1669                     ; 637     CLK->CKDIVR |= (u8)((u8)ClockPrescaler & (u8)CLK_CKDIVR_CPUDIV);
1671  0226 7b01          	ld	a,(OFST+1,sp)
1672  0228 a407          	and	a,#7
1673  022a ca50c6        	or	a,20678
1674  022d c750c6        	ld	20678,a
1675  0230               L337:
1676                     ; 640 }
1679  0230 84            	pop	a
1680  0231 81            	ret
1736                     ; 654 void CLK_SWIMConfig(CLK_SWIMDivider_TypeDef CLK_SWIMDivider)
1736                     ; 655 {
1737                     	switch	.text
1738  0232               _CLK_SWIMConfig:
1742                     ; 658   assert_param(IS_CLK_SWIMDIVIDER_OK(CLK_SWIMDivider));
1744                     ; 660   if (CLK_SWIMDivider != CLK_SWIMDIVIDER_2)
1746  0232 4d            	tnz	a
1747  0233 2706          	jreq	L367
1748                     ; 663     CLK->SWIMCCR |= CLK_SWIMCCR_SWIMDIV;
1750  0235 721050cd      	bset	20685,#0
1752  0239 2004          	jra	L567
1753  023b               L367:
1754                     ; 668     CLK->SWIMCCR &= (u8)(~CLK_SWIMCCR_SWIMDIV);
1756  023b 721150cd      	bres	20685,#0
1757  023f               L567:
1758                     ; 671 }
1761  023f 81            	ret
1858                     ; 686 void CLK_CANConfig(CLK_CANDivider_TypeDef CLK_CANDivider)
1858                     ; 687 {
1859                     	switch	.text
1860  0240               _CLK_CANConfig:
1862  0240 88            	push	a
1863       00000000      OFST:	set	0
1866                     ; 690   assert_param(IS_CLK_CANDIVIDER_OK(CLK_CANDivider));
1868                     ; 693   CLK->CANCCR &= (u8)(~CLK_CANCCR_CANDIV);
1870  0241 c650cb        	ld	a,20683
1871  0244 a4f8          	and	a,#248
1872  0246 c750cb        	ld	20683,a
1873                     ; 696   CLK->CANCCR |= (u8)CLK_CANDivider;
1875  0249 c650cb        	ld	a,20683
1876  024c 1a01          	or	a,(OFST+1,sp)
1877  024e c750cb        	ld	20683,a
1878                     ; 698 }
1881  0251 84            	pop	a
1882  0252 81            	ret
1906                     ; 715 void CLK_ClockSecuritySystemEnable(void)
1906                     ; 716 {
1907                     	switch	.text
1908  0253               _CLK_ClockSecuritySystemEnable:
1912                     ; 718   CLK->CSSR |= CLK_CSSR_CSSEN;
1914  0253 721050c8      	bset	20680,#0
1915                     ; 719 }
1918  0257 81            	ret
1943                     ; 736 CLK_Source_TypeDef CLK_GetSYSCLKSource(void)
1943                     ; 737 {
1944                     	switch	.text
1945  0258               _CLK_GetSYSCLKSource:
1949                     ; 738   return((CLK_Source_TypeDef)CLK->CMSR);
1951  0258 c650c3        	ld	a,20675
1954  025b 81            	ret
2017                     ; 756 u32 CLK_GetClockFreq(void)
2017                     ; 757 {
2018                     	switch	.text
2019  025c               _CLK_GetClockFreq:
2021  025c 5209          	subw	sp,#9
2022       00000009      OFST:	set	9
2025                     ; 759   u32 clockfrequency = 0;
2027  025e 96            	ldw	x,sp
2028  025f 1c0005        	addw	x,#OFST-4
2029  0262 cd0000        	call	c_ltor
2031                     ; 760   CLK_Source_TypeDef clocksource = CLK_SOURCE_HSI;
2033  0265 7b09          	ld	a,(OFST+0,sp)
2034  0267 97            	ld	xl,a
2035                     ; 761   u8 tmp = 0, presc = 0;
2037  0268 7b09          	ld	a,(OFST+0,sp)
2038  026a 97            	ld	xl,a
2041  026b 7b09          	ld	a,(OFST+0,sp)
2042  026d 97            	ld	xl,a
2043                     ; 764   clocksource = (CLK_Source_TypeDef)CLK->CMSR;
2045  026e c650c3        	ld	a,20675
2046  0271 6b09          	ld	(OFST+0,sp),a
2047                     ; 766   if (clocksource == CLK_SOURCE_HSI)
2049  0273 7b09          	ld	a,(OFST+0,sp)
2050  0275 a1e1          	cp	a,#225
2051  0277 2642          	jrne	L3011
2052                     ; 768     tmp = (u8)(CLK->CKDIVR & CLK_CKDIVR_HSIDIV);
2054  0279 c650c6        	ld	a,20678
2055  027c a418          	and	a,#24
2056  027e 6b09          	ld	(OFST+0,sp),a
2057                     ; 769     tmp = (u8)(tmp >> 3);
2059  0280 7b09          	ld	a,(OFST+0,sp)
2060  0282 44            	srl	a
2061  0283 44            	srl	a
2062  0284 44            	srl	a
2063  0285 6b09          	ld	(OFST+0,sp),a
2064                     ; 770     presc = HSIDivFactor[tmp];
2066  0287 7b09          	ld	a,(OFST+0,sp)
2067  0289 5f            	clrw	x
2068  028a 97            	ld	xl,a
2069  028b d60000        	ld	a,(_HSIDivFactor,x)
2070  028e 6b09          	ld	(OFST+0,sp),a
2071                     ; 771     clockfrequency = HSI_VALUE / presc;
2073  0290 7b09          	ld	a,(OFST+0,sp)
2074  0292 b703          	ld	c_lreg+3,a
2075  0294 3f02          	clr	c_lreg+2
2076  0296 3f01          	clr	c_lreg+1
2077  0298 3f00          	clr	c_lreg
2078  029a 96            	ldw	x,sp
2079  029b 1c0001        	addw	x,#OFST-8
2080  029e cd0000        	call	c_rtol
2082  02a1 ae2400        	ldw	x,#9216
2083  02a4 bf02          	ldw	c_lreg+2,x
2084  02a6 ae00f4        	ldw	x,#244
2085  02a9 bf00          	ldw	c_lreg,x
2086  02ab 96            	ldw	x,sp
2087  02ac 1c0001        	addw	x,#OFST-8
2088  02af cd0000        	call	c_ludv
2090  02b2 96            	ldw	x,sp
2091  02b3 1c0005        	addw	x,#OFST-4
2092  02b6 cd0000        	call	c_rtol
2095  02b9 201c          	jra	L5011
2096  02bb               L3011:
2097                     ; 773   else if ( clocksource == CLK_SOURCE_LSI)
2099  02bb 7b09          	ld	a,(OFST+0,sp)
2100  02bd a1d2          	cp	a,#210
2101  02bf 260c          	jrne	L7011
2102                     ; 775     clockfrequency = LSI_VALUE;
2104  02c1 aef400        	ldw	x,#62464
2105  02c4 1f07          	ldw	(OFST-2,sp),x
2106  02c6 ae0001        	ldw	x,#1
2107  02c9 1f05          	ldw	(OFST-4,sp),x
2109  02cb 200a          	jra	L5011
2110  02cd               L7011:
2111                     ; 779     clockfrequency = HSE_VALUE;
2113  02cd ae3600        	ldw	x,#13824
2114  02d0 1f07          	ldw	(OFST-2,sp),x
2115  02d2 ae016e        	ldw	x,#366
2116  02d5 1f05          	ldw	(OFST-4,sp),x
2117  02d7               L5011:
2118                     ; 782   return((u32)clockfrequency);
2120  02d7 96            	ldw	x,sp
2121  02d8 1c0005        	addw	x,#OFST-4
2122  02db cd0000        	call	c_ltor
2126  02de 5b09          	addw	sp,#9
2127  02e0 81            	ret
2226                     ; 800 void CLK_AdjustHSICalibrationValue(CLK_HSITrimValue_TypeDef CLK_HSICalibrationValue)
2226                     ; 801 {
2227                     	switch	.text
2228  02e1               _CLK_AdjustHSICalibrationValue:
2230  02e1 88            	push	a
2231       00000000      OFST:	set	0
2234                     ; 804   assert_param(IS_CLK_HSITRIMVALUE_OK(CLK_HSICalibrationValue));
2236                     ; 807   CLK->HSITRIMR &= (u8)(~CLK_HSITRIMR_HSITRIM);
2238  02e2 c650cc        	ld	a,20684
2239  02e5 a4f8          	and	a,#248
2240  02e7 c750cc        	ld	20684,a
2241                     ; 810   CLK->HSITRIMR |= (u8)CLK_HSICalibrationValue;
2243  02ea c650cc        	ld	a,20684
2244  02ed 1a01          	or	a,(OFST+1,sp)
2245  02ef c750cc        	ld	20684,a
2246                     ; 812 }
2249  02f2 84            	pop	a
2250  02f3 81            	ret
2274                     ; 831 void CLK_SYSCLKEmergencyClear(void)
2274                     ; 832 {
2275                     	switch	.text
2276  02f4               _CLK_SYSCLKEmergencyClear:
2280                     ; 833   CLK->SWCR &= (u8)(~CLK_SWCR_SWBSY);
2282  02f4 721150c5      	bres	20677,#0
2283                     ; 834 }
2286  02f8 81            	ret
2439                     ; 850 FlagStatus CLK_GetFlagStatus(CLK_Flag_TypeDef CLK_FLAG)
2439                     ; 851 {
2440                     	switch	.text
2441  02f9               _CLK_GetFlagStatus:
2443  02f9 89            	pushw	x
2444  02fa 5203          	subw	sp,#3
2445       00000003      OFST:	set	3
2448                     ; 853   u16 statusreg = 0;
2450  02fc 1e01          	ldw	x,(OFST-2,sp)
2451                     ; 854   u8 tmpreg = 0;
2453  02fe 7b03          	ld	a,(OFST+0,sp)
2454  0300 97            	ld	xl,a
2455                     ; 855   FlagStatus bitstatus = RESET;
2457  0301 7b03          	ld	a,(OFST+0,sp)
2458  0303 97            	ld	xl,a
2459                     ; 858   assert_param(IS_CLK_FLAG_OK(CLK_FLAG));
2461                     ; 861   statusreg = (u16)((u16)CLK_FLAG & (u16)0xFF00);
2463  0304 7b04          	ld	a,(OFST+1,sp)
2464  0306 97            	ld	xl,a
2465  0307 7b05          	ld	a,(OFST+2,sp)
2466  0309 9f            	ld	a,xl
2467  030a a4ff          	and	a,#255
2468  030c 97            	ld	xl,a
2469  030d 4f            	clr	a
2470  030e 02            	rlwa	x,a
2471  030f 1f01          	ldw	(OFST-2,sp),x
2472  0311 01            	rrwa	x,a
2473                     ; 864   if (statusreg == 0x0100) /* The flag to check is in ICKRregister */
2475  0312 1e01          	ldw	x,(OFST-2,sp)
2476  0314 a30100        	cpw	x,#256
2477  0317 2607          	jrne	L5521
2478                     ; 866     tmpreg = CLK->ICKR;
2480  0319 c650c0        	ld	a,20672
2481  031c 6b03          	ld	(OFST+0,sp),a
2483  031e 202f          	jra	L7521
2484  0320               L5521:
2485                     ; 868   else if (statusreg == 0x0200) /* The flag to check is in ECKRregister */
2487  0320 1e01          	ldw	x,(OFST-2,sp)
2488  0322 a30200        	cpw	x,#512
2489  0325 2607          	jrne	L1621
2490                     ; 870     tmpreg = CLK->ECKR;
2492  0327 c650c1        	ld	a,20673
2493  032a 6b03          	ld	(OFST+0,sp),a
2495  032c 2021          	jra	L7521
2496  032e               L1621:
2497                     ; 872   else if (statusreg == 0x0300) /* The flag to check is in SWIC register */
2499  032e 1e01          	ldw	x,(OFST-2,sp)
2500  0330 a30300        	cpw	x,#768
2501  0333 2607          	jrne	L5621
2502                     ; 874     tmpreg = CLK->SWCR;
2504  0335 c650c5        	ld	a,20677
2505  0338 6b03          	ld	(OFST+0,sp),a
2507  033a 2013          	jra	L7521
2508  033c               L5621:
2509                     ; 876   else if (statusreg == 0x0400) /* The flag to check is in CSS register */
2511  033c 1e01          	ldw	x,(OFST-2,sp)
2512  033e a30400        	cpw	x,#1024
2513  0341 2607          	jrne	L1721
2514                     ; 878     tmpreg = CLK->CSSR;
2516  0343 c650c8        	ld	a,20680
2517  0346 6b03          	ld	(OFST+0,sp),a
2519  0348 2005          	jra	L7521
2520  034a               L1721:
2521                     ; 882     tmpreg = CLK->CCOR;
2523  034a c650c9        	ld	a,20681
2524  034d 6b03          	ld	(OFST+0,sp),a
2525  034f               L7521:
2526                     ; 885   if ((tmpreg & (u8)CLK_FLAG) != (u8)RESET)
2528  034f 7b05          	ld	a,(OFST+2,sp)
2529  0351 1503          	bcp	a,(OFST+0,sp)
2530  0353 2706          	jreq	L5721
2531                     ; 887     bitstatus = SET;
2533  0355 a601          	ld	a,#1
2534  0357 6b03          	ld	(OFST+0,sp),a
2536  0359 2002          	jra	L7721
2537  035b               L5721:
2538                     ; 891     bitstatus = RESET;
2540  035b 0f03          	clr	(OFST+0,sp)
2541  035d               L7721:
2542                     ; 895   return((FlagStatus)bitstatus);
2544  035d 7b03          	ld	a,(OFST+0,sp)
2547  035f 5b05          	addw	sp,#5
2548  0361 81            	ret
2594                     ; 916 ITStatus CLK_GetITStatus(CLK_IT_TypeDef CLK_IT)
2594                     ; 917 {
2595                     	switch	.text
2596  0362               _CLK_GetITStatus:
2598  0362 88            	push	a
2599       00000001      OFST:	set	1
2602                     ; 919   ITStatus bitstatus = RESET;
2604  0363 0f01          	clr	(OFST+0,sp)
2605                     ; 922   assert_param(IS_CLK_IT_OK(CLK_IT));
2607                     ; 924   if (CLK_IT == CLK_IT_SWIE)
2609  0365 a101          	cp	a,#1
2610  0367 2611          	jrne	L3231
2611                     ; 927     if ((CLK->SWCR & (u8)CLK_SWCR_SWIEN) != (u8)RESET)
2613  0369 c650c5        	ld	a,20677
2614  036c a504          	bcp	a,#4
2615  036e 2706          	jreq	L5231
2616                     ; 929       bitstatus = SET;
2618  0370 a601          	ld	a,#1
2619  0372 6b01          	ld	(OFST+0,sp),a
2621  0374 2013          	jra	L1331
2622  0376               L5231:
2623                     ; 933       bitstatus = RESET;
2625  0376 0f01          	clr	(OFST+0,sp)
2626  0378 200f          	jra	L1331
2627  037a               L3231:
2628                     ; 939     if ((CLK->CSSR & (u8)CLK_CSSR_CSSDIE) != (u8)RESET)
2630  037a c650c8        	ld	a,20680
2631  037d a504          	bcp	a,#4
2632  037f 2706          	jreq	L3331
2633                     ; 941       bitstatus = SET;
2635  0381 a601          	ld	a,#1
2636  0383 6b01          	ld	(OFST+0,sp),a
2638  0385 2002          	jra	L1331
2639  0387               L3331:
2640                     ; 945       bitstatus = RESET;
2642  0387 0f01          	clr	(OFST+0,sp)
2643  0389               L1331:
2644                     ; 950   return bitstatus;
2646  0389 7b01          	ld	a,(OFST+0,sp)
2649  038b 5b01          	addw	sp,#1
2650  038d 81            	ret
2708                     ; 969 void CLK_ClearITPendingBit(CLK_PendingBit_TypeDef CLK_PendingBit)
2708                     ; 970 {
2709                     	switch	.text
2710  038e               _CLK_ClearITPendingBit:
2714                     ; 973   assert_param(IS_CLK_PENDINGBIT_OK(CLK_PendingBit));
2716                     ; 975   if (CLK_PendingBit == (u8)CLK_PENDINGBIT_CSSD)
2718  038e 4d            	tnz	a
2719  038f 2606          	jrne	L5631
2720                     ; 978     CLK->CSSR &= (u8)(~CLK_CSSR_CSSD);
2722  0391 721750c8      	bres	20680,#3
2724  0395 2004          	jra	L7631
2725  0397               L5631:
2726                     ; 983     CLK->SWCR &= (u8)(~CLK_SWCR_SWIF);
2728  0397 721750c5      	bres	20677,#3
2729  039b               L7631:
2730                     ; 986 }
2733  039b 81            	ret
2768                     	xdef	_CLKPrescTable
2769                     	xdef	_HSIDivFactor
2770                     	xdef	_CLK_ClearITPendingBit
2771                     	xdef	_CLK_GetITStatus
2772                     	xdef	_CLK_GetFlagStatus
2773                     	xdef	_CLK_GetSYSCLKSource
2774                     	xdef	_CLK_GetClockFreq
2775                     	xdef	_CLK_AdjustHSICalibrationValue
2776                     	xdef	_CLK_SYSCLKEmergencyClear
2777                     	xdef	_CLK_ClockSecuritySystemEnable
2778                     	xdef	_CLK_CANConfig
2779                     	xdef	_CLK_SWIMConfig
2780                     	xdef	_CLK_SYSCLKConfig
2781                     	xdef	_CLK_ITConfig
2782                     	xdef	_CLK_CCOConfig
2783                     	xdef	_CLK_HSIPrescalerConfig
2784                     	xdef	_CLK_ClockSwitchConfig
2785                     	xdef	_CLK_PeripheralClockConfig
2786                     	xdef	_CLK_SlowActiveHaltWakeUpCmd
2787                     	xdef	_CLK_FastHaltWakeUpCmd
2788                     	xdef	_CLK_ClockSwitchCmd
2789                     	xdef	_CLK_CCOCmd
2790                     	xdef	_CLK_LSICmd
2791                     	xdef	_CLK_HSICmd
2792                     	xdef	_CLK_HSECmd
2793                     	xdef	_CLK_DeInit
2794                     	xref.b	c_lreg
2813                     	xref	c_ludv
2814                     	xref	c_rtol
2815                     	xref	c_ltor
2816                     	end
